#include "stdafx.h"
#include "OSMCtrlApp.h"
#include "MainFrm.h"
#include "OSMCtrlAppDoc.h"
#include "OSMCtrlAppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif //#ifdef _DEBUG


#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(COSMCtrlAppApp, CWinApp) //NOLINT(modernize-avoid-c-arrays)
  ON_COMMAND(ID_APP_ABOUT, &COSMCtrlAppApp::OnAppAbout)
  ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
  ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
  ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

COSMCtrlAppApp::COSMCtrlAppApp() noexcept : m_GDIPlusToken{0}
{
}

//The one and only ATL module object
#pragma warning(suppress: 26426)
ATL::CComModule _Module;

//The one and only MFC app object
#pragma warning(suppress: 26426)
COSMCtrlAppApp theApp;


BOOL COSMCtrlAppApp::InitInstance()
{
  //Initialize OLE
  if (!AfxOleInit())
  {
    AfxMessageBox(IDS_OLE_INIT_FAILED, MB_OK | MB_ICONSTOP);
    return FALSE;
  }

  //Initialize GDI+
#ifdef COSMCTRL_NOD2D
  const Gdiplus::GdiplusStartupInput gdiplusStartupInput;
#pragma warning(suppress: 26486)
  if (Gdiplus::GdiplusStartup(&m_GDIPlusToken, &gdiplusStartupInput, nullptr) != Gdiplus::Ok)
  {
    AfxMessageBox(_T("Failed to initialize GDI+"), MB_OK | MB_ICONSTOP);
    return FALSE;
  }
#endif //#ifdef COSMCTRL_NOD2D

  INITCOMMONCONTROLSEX InitCtrls;
  InitCtrls.dwSize = sizeof(InitCtrls);
  InitCtrls.dwICC = ICC_WIN95_CLASSES;
  InitCommonControlsEx(&InitCtrls);

#ifdef _DEBUG //Just some test code to exercise the various methods which implement Vincenty's algorithms
  COSMCtrlPosition pos1{-77.04978, 38.88922};
  double dEndBearing{0};
  COSMCtrlPosition pos2{COSMCtrlHelper::GetPosition(pos1, 51.7679, 6179016.13586, &dEndBearing)};
  double dStartBearing{0};
  const double dDistance{COSMCtrlHelper::DistanceBetweenPoints(pos1, pos2, &dStartBearing, &dEndBearing)};
  UNREFERENCED_PARAMETER(dDistance);

  //Do the reverse test
  const COSMCtrlPosition pos3{2.29583, 48.85889};
  double dStartBearing2{0};
  double dEndBearing2{0};
  const double dDistance2{COSMCtrlHelper::DistanceBetweenPoints(pos1, pos3, &dStartBearing2, &dEndBearing2)};

  pos1 = COSMCtrlPosition{175.04978, 38.88922};
  pos2 = COSMCtrlHelper::GetPosition(pos1, 90, 8000, &dEndBearing);

  pos1 = COSMCtrlPosition{-77.04978, 38.88922};
  double dEndBearing3{0};
  const COSMCtrlPosition pos4{COSMCtrlHelper::GetPosition(pos1, dStartBearing2, dDistance2, &dEndBearing3)};
  UNREFERENCED_PARAMETER(pos4);

  const COSMCtrlPosition pos5{-180, 0};
  const COSMCtrlPosition pos6{0, 0};
  double dStartBearing5{0};
  double dEndBearing5{0};
  const double dDistance5{COSMCtrlHelper::DistanceBetweenPoints(pos5, pos6, &dStartBearing5, &dEndBearing5)};
  UNREFERENCED_PARAMETER(dDistance5);

  const COSMCtrlPosition pos7{0, 0};
  const COSMCtrlPosition pos8{-180, 0};
  double dStartBearing7{0};
  double dEndBearing7{0};
  const double dDistance7{COSMCtrlHelper::DistanceBetweenPoints(pos7, pos8, &dStartBearing7, &dEndBearing7)};
  UNREFERENCED_PARAMETER(dDistance7);

  const COSMCtrlPosition pos9{0, 90};
  const COSMCtrlPosition pos10{0, -90};
  double dStartBearing9{0};
  double dEndBearing9{0};
  const double dDistance9{COSMCtrlHelper::DistanceBetweenPoints(pos9, pos10, &dStartBearing9, &dEndBearing9)};
  UNREFERENCED_PARAMETER(dDistance9);

  const COSMCtrlPosition pos11(0, -90);
  const COSMCtrlPosition pos12(0, 90);
  double dStartBearing11 = 0;
  double dEndBearing11 = 0;
  const double dDistance11 = COSMCtrlHelper::DistanceBetweenPoints(pos11, pos12, &dStartBearing11, &dEndBearing11);
  UNREFERENCED_PARAMETER(dDistance11);

  const COSMCtrlPosition pos13{0, 60};
  const COSMCtrlPosition pos14{180, -60};
  double dStartBearing13{0};
  double dEndBearing13{0};
  const double dDistance13{COSMCtrlHelper::DistanceBetweenPoints(pos13, pos14, &dStartBearing13, &dEndBearing13)};
  UNREFERENCED_PARAMETER(dDistance13);

  const COSMCtrlPosition pos15{180, -60};
  const COSMCtrlPosition pos16{0, 60};
  double dStartBearing15{0};
  double dEndBearing15{0};
  const double dDistance15{COSMCtrlHelper::DistanceBetweenPoints(pos15, pos16, &dStartBearing15, &dEndBearing15)};
  UNREFERENCED_PARAMETER(dDistance15);
#endif //#ifdef _DEBUG

  if (!__super::InitInstance())
    return FALSE;
  SetRegistryKey(_T("Local AppWizard-Generated Applications"));
  LoadStdProfileSettings(4); //Load standard INI file options (including MRU)
#pragma warning(suppress: 26400 26403 26409)
  auto pDocTemplate{new CSingleDocTemplate(IDR_MAINFRAME, RUNTIME_CLASS(COSMCtrlAppDoc),
                                           RUNTIME_CLASS(CMainFrame), RUNTIME_CLASS(COSMCtrlAppView))};
  if (pDocTemplate == nullptr)
    return FALSE;
  AddDocTemplate(pDocTemplate);
  CCommandLineInfo cmdInfo;
  ParseCommandLine(cmdInfo);
  if (!ProcessShellCommand(cmdInfo))
    return FALSE;
  m_pMainWnd->ShowWindow(SW_SHOW);
  m_pMainWnd->UpdateWindow();

  return TRUE;
}

class CAboutDlg : public CDialog
{
public:
//Constructors / Destructors
  CAboutDlg();
  CAboutDlg(const CAboutDlg&) = delete;
  CAboutDlg(CAboutDlg&&) = delete;
  ~CAboutDlg() = default; //NOLINT(modernize-use-override)

//Methods
  CAboutDlg& operator=(const CAboutDlg&) = delete;
  CAboutDlg& operator=(CAboutDlg&&) = delete;

protected:
//Member variables
  enum { IDD = IDD_ABOUTBOX };
  CLinkCtrl m_ctrlLicenseDetails;

//Methods
  void DoDataExchange(CDataExchange* pDX) override;

//Message handlers
  afx_msg void OnNMClickLicenseDetails(NMHDR* pNMHDR, LRESULT* pResult);

  DECLARE_MESSAGE_MAP()
};

#pragma warning(suppress: 26455)
CAboutDlg::CAboutDlg() : CDialog{CAboutDlg::IDD}
{
}

#pragma warning(suppress: 26433)
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_LICENSE_DETAILS, m_ctrlLicenseDetails);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
#pragma warning(suppress: 26454)
  ON_NOTIFY(NM_CLICK, IDC_LICENSE_DETAILS, &CAboutDlg::OnNMClickLicenseDetails)
END_MESSAGE_MAP()

#pragma warning(suppress: 26429 26440 26461)
void CAboutDlg::OnNMClickLicenseDetails(NMHDR* pNMHDR, LRESULT* pResult)
{
#pragma warning(suppress: 26490)
  const auto pNMLink{reinterpret_cast<const NMLINK*>(pNMHDR)};
#pragma warning(suppress: 26485)
  ShellExecuteW(nullptr, L"open", pNMLink->item.szUrl, nullptr, nullptr, SW_SHOWNORMAL);
  *pResult = 0;
}


void COSMCtrlAppApp::OnAppAbout()
{
  CAboutDlg aboutDlg;
  if (aboutDlg.DoModal() == -1)
  {
    //Display an error message if we could not show the dialog
    AfxMessageBox(_T("Unable to show the About dialog. Please ensure that you are running a Unicode build of the app as the dialog uses SysLink controls which are only supported for Unicode"), MB_OK | MB_ICONSTOP);
  }
}

int COSMCtrlAppApp::ExitInstance()
{
#ifdef COSMCTRL_NOD2D
  //Shutdown GDI+
  Gdiplus::GdiplusShutdown(m_GDIPlusToken);
#endif //#ifdef COSMCTRL_NOD2D

  //Let the base class do its thing
  return __super::ExitInstance();
}
