#include "stdafx.h"
#include "OSMCtrlApp.h"
#include "OSMCtrlAppDoc.h"
#include "OSMCtrlAppView.h"
#include "TilePropertiesDlg.h"
#include "GpsSettingsDlg.h"
#include "cnominatim.h" //If you get a compilation error about this missing header file, then you need to download my CNominatim class from http://www.naughter.com/nominatim.html
#include "SearchDlg.h"
#include "SearchResultsDlg.h"
#include "GotoCoordinatesDlg.h"
#include "SettingsDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif //#ifdef _DEBUG

constexpr int DELAY_BEFORE_RECENTER{10000};
constexpr int DELAY_BEFORE_RESET_BEARING{10000};
constexpr const TCHAR* g_pszGPXCreator{_T("CGPX / COSMCtrl - http://www.naughter.com/osmctrl.html")};

enum class OSMCtrlAppTileProvider
{
  Mapnik,
  Cyclemap
};


#pragma warning(suppress: 26433)
STDMETHODIMP CMySensorEvents::OnDataUpdated(__RPC__in_opt ISensor* pSensor, __RPC__in_opt ISensorDataReport* pNewData) //NOLINT(clang-diagnostic-microsoft-exception-spec)
{
  //Get the pointer back to the view class
  POSITION posTemplate{theApp.GetFirstDocTemplatePosition()};
#pragma warning(suppress: 26429)
  const CDocTemplate* pDocTemplate{theApp.GetNextDocTemplate(posTemplate)};
  ASSERT(pDocTemplate != nullptr);
  POSITION posDoc{pDocTemplate->GetFirstDocPosition()};
  const CDocument* pDoc{pDocTemplate->GetNextDoc(posDoc)};
  if (pDoc != nullptr)
  {
    POSITION posView{pDoc->GetFirstViewPosition()};
#pragma warning(suppress: 26466)
    auto pView{static_cast<COSMCtrlAppView*>(pDoc->GetNextView(posView))};
#pragma warning(suppress: 26496)
    AFXASSUME(pView != nullptr);
    ASSERT(pView->IsKindOf(RUNTIME_CLASS(COSMCtrlAppView)));

    //Delegate all the work back to the view class
    return pView->OnDataUpdated(pSensor, pNewData);
  }
  else
    return E_FAIL;
}

#pragma warning(suppress: 26433)
STDMETHODIMP CMySensorEvents::OnLeave(__RPC__in_opt REFSENSOR_ID sensorID) //NOLINT(clang-diagnostic-microsoft-exception-spec)
{
  //Get the pointer back to the view class
  POSITION posTemplate{theApp.GetFirstDocTemplatePosition()};
#pragma warning(suppress: 26429)
  const CDocTemplate* pDocTemplate{theApp.GetNextDocTemplate(posTemplate)};
  ASSERT(pDocTemplate != nullptr);
  POSITION posDoc{pDocTemplate->GetFirstDocPosition()};
  const CDocument* pDoc{pDocTemplate->GetNextDoc(posDoc)};
  if (pDoc != nullptr)
  {
    POSITION posView{pDoc->GetFirstViewPosition()};
#pragma warning(suppress: 26466)
    auto pView{static_cast<COSMCtrlAppView*>(pDoc->GetNextView(posView))};
#pragma warning(suppress: 26496)
    AFXASSUME(pView != nullptr);
    ASSERT(pView->IsKindOf(RUNTIME_CLASS(COSMCtrlAppView)));

    //Delegate all the work back to the view class
    return pView->OnLeave(sensorID);
  }
  else
    return E_FAIL;
}


#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(COSMCtrlAppView, CView)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(COSMCtrlAppView, CView) //NOLINT(modernize-avoid-c-arrays)
  ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
  ON_WM_CREATE()
  ON_WM_ERASEBKGND()
  ON_COMMAND(ID_ZOOM_0, &COSMCtrlAppView::OnZoom0)
  ON_COMMAND(ID_ZOOM_1, &COSMCtrlAppView::OnZoom1)
  ON_COMMAND(ID_ZOOM_2, &COSMCtrlAppView::OnZoom2)
  ON_COMMAND(ID_ZOOM_3, &COSMCtrlAppView::OnZoom3)
  ON_COMMAND(ID_ZOOM_4, &COSMCtrlAppView::OnZoom4)
  ON_COMMAND(ID_ZOOM_5, &COSMCtrlAppView::OnZoom5)
  ON_COMMAND(ID_ZOOM_6, &COSMCtrlAppView::OnZoom6)
  ON_COMMAND(ID_ZOOM_7, &COSMCtrlAppView::OnZoom7)
  ON_COMMAND(ID_ZOOM_8, &COSMCtrlAppView::OnZoom8)
  ON_COMMAND(ID_ZOOM_9, &COSMCtrlAppView::OnZoom9)
  ON_COMMAND(ID_ZOOM_10, &COSMCtrlAppView::OnZoom10)
  ON_COMMAND(ID_ZOOM_11, &COSMCtrlAppView::OnZoom11)
  ON_COMMAND(ID_ZOOM_12, &COSMCtrlAppView::OnZoom12)
  ON_COMMAND(ID_ZOOM_13, &COSMCtrlAppView::OnZoom13)
  ON_COMMAND(ID_ZOOM_14, &COSMCtrlAppView::OnZoom14)
  ON_COMMAND(ID_ZOOM_15, &COSMCtrlAppView::OnZoom15)
  ON_COMMAND(ID_ZOOM_16, &COSMCtrlAppView::OnZoom16)
  ON_COMMAND(ID_ZOOM_17, &COSMCtrlAppView::OnZoom17)
  ON_COMMAND(ID_ZOOM_18, &COSMCtrlAppView::OnZoom18)
  ON_COMMAND(ID_ZOOM_TO_SELECTION, &COSMCtrlAppView::OnZoomToSelection)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_0, &COSMCtrlAppView::OnUpdateZoom0)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_1, &COSMCtrlAppView::OnUpdateZoom1)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_2, &COSMCtrlAppView::OnUpdateZoom2)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_3, &COSMCtrlAppView::OnUpdateZoom3)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_4, &COSMCtrlAppView::OnUpdateZoom4)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_5, &COSMCtrlAppView::OnUpdateZoom5)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_6, &COSMCtrlAppView::OnUpdateZoom6)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_7, &COSMCtrlAppView::OnUpdateZoom7)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_8, &COSMCtrlAppView::OnUpdateZoom8)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_9, &COSMCtrlAppView::OnUpdateZoom9)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_10, &COSMCtrlAppView::OnUpdateZoom10)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_11, &COSMCtrlAppView::OnUpdateZoom11)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_12, &COSMCtrlAppView::OnUpdateZoom12)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_13, &COSMCtrlAppView::OnUpdateZoom13)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_14, &COSMCtrlAppView::OnUpdateZoom14)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_15, &COSMCtrlAppView::OnUpdateZoom15)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_16, &COSMCtrlAppView::OnUpdateZoom16)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_17, &COSMCtrlAppView::OnUpdateZoom17)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_18, &COSMCtrlAppView::OnUpdateZoom18)
  ON_UPDATE_COMMAND_UI(ID_ZOOM_TO_SELECTION, &COSMCtrlAppView::OnUpdateZoomToSelection)
  ON_WM_SETFOCUS()
  ON_UPDATE_COMMAND_UI(ID_VIEW_AUTODOWNLOADTILES, &COSMCtrlAppView::OnUpdateViewAutoDownloadTiles)
  ON_COMMAND(ID_VIEW_AUTODOWNLOADTILES, &COSMCtrlAppView::OnViewAutoDownloadTiles)
  ON_COMMAND(ID_PROVIDERS_MAPNIK, &COSMCtrlAppView::OnProvidersMapnik)
  ON_UPDATE_COMMAND_UI(ID_PROVIDERS_MAPNIK, &COSMCtrlAppView::OnUpdateProvidersMapnik)
  ON_WM_DESTROY()
  ON_COMMAND(ID_VIEW_CLEARCACHE, &COSMCtrlAppView::OnViewClearCache)
  ON_UPDATE_COMMAND_UI(ID_PROVIDERS_CYCLEMAP, &COSMCtrlAppView::OnUpdateProvidersCyclemap)
  ON_COMMAND(ID_PROVIDERS_CYCLEMAP, &COSMCtrlAppView::OnProvidersCyclemap)
  ON_WM_SIZE()
  ON_COMMAND(ID_VIEW_REFRESH, &COSMCtrlAppView::OnViewRefresh)
  ON_COMMAND(ID_VIEW_DRAWSCROLLROSE, &COSMCtrlAppView::OnViewDrawScrollRose)
  ON_UPDATE_COMMAND_UI(ID_VIEW_DRAWSCROLLROSE, &COSMCtrlAppView::OnUpdateViewDrawScrollRose)
  ON_COMMAND(ID_VIEW_DRAWZOOMBAR, &COSMCtrlAppView::OnViewDrawZoomBar)
  ON_UPDATE_COMMAND_UI(ID_VIEW_DRAWZOOMBAR, &COSMCtrlAppView::OnUpdateViewDrawZoomBar)
  ON_COMMAND(ID_VIEW_ALLOWDRAG, &COSMCtrlAppView::OnViewAllowDrag)
  ON_UPDATE_COMMAND_UI(ID_VIEW_ALLOWDRAG, &COSMCtrlAppView::OnUpdateViewAllowDrag)
  ON_COMMAND(ID_VIEW_ALLOWKEYBOARD, &COSMCtrlAppView::OnViewAllowKeyboard)
  ON_UPDATE_COMMAND_UI(ID_VIEW_ALLOWKEYBOARD, &COSMCtrlAppView::OnUpdateViewAllowKeyboard)
  ON_COMMAND(ID_VIEW_ALLOWMOUSEZOOM, &COSMCtrlAppView::OnViewAllowMouseZoom)
  ON_UPDATE_COMMAND_UI(ID_VIEW_ALLOWMOUSEZOOM, &COSMCtrlAppView::OnUpdateViewAllowMouseZoom)
  ON_COMMAND(ID_VIEW_DRAWSCALEBAR, &COSMCtrlAppView::OnViewDrawScaleBar)
  ON_UPDATE_COMMAND_UI(ID_VIEW_DRAWSCALEBAR, &COSMCtrlAppView::OnUpdateViewDrawScaleBar)
  ON_COMMAND(ID_VIEW_ALLOWPREVIOUSZOOMSTRETCH, &COSMCtrlAppView::OnViewAllowPreviousZoomStretch)
  ON_UPDATE_COMMAND_UI(ID_VIEW_ALLOWPREVIOUSZOOMSTRETCH, &COSMCtrlAppView::OnUpdateViewAllowPreviousZoomStretch)
  ON_COMMAND(ID_VIEW_ALLOWNEXTZOOMSQUEEZE, &COSMCtrlAppView::OnViewAllowNextZoomSqueeze)
  ON_UPDATE_COMMAND_UI(ID_VIEW_ALLOWNEXTZOOMSQUEEZE, &COSMCtrlAppView::OnUpdateViewAllowNextZoomSqueeze)
  ON_COMMAND(ID_VIEW_DOWNLOADTILESFROMCENTEROUTWARDS, &COSMCtrlAppView::OnViewDownloadTilesFromCenterOutwards)
  ON_UPDATE_COMMAND_UI(ID_VIEW_DOWNLOADTILESFROMCENTEROUTWARDS, &COSMCtrlAppView::OnUpdateViewDownloadTilesFromCenterOutwards)
  ON_COMMAND(ID_VIEW_USETRANSPARENCYFORZOOMBAR, &COSMCtrlAppView::OnViewUseTransparencyforZoomBar)
  ON_UPDATE_COMMAND_UI(ID_VIEW_USETRANSPARENCYFORZOOMBAR, &COSMCtrlAppView::OnUpdateViewUseTransparencyForZoomBar)
  ON_COMMAND(ID_VIEW_DRAWTILEOUTLINES, &COSMCtrlAppView::OnViewDrawTileOutlines)
  ON_UPDATE_COMMAND_UI(ID_VIEW_DRAWTILEOUTLINES, &COSMCtrlAppView::OnUpdateViewDrawTileOutlines)
  ON_WM_CONTEXTMENU()
  ON_COMMAND(ID_VIEW_TILEPROPERTIES, &COSMCtrlAppView::OnViewTileProperties)
  ON_COMMAND(ID_VIEW_DRAWZOOMBARASSLIDERCONTROL, &COSMCtrlAppView::OnViewDrawZoomBarAaSliderControl)
  ON_UPDATE_COMMAND_UI(ID_VIEW_DRAWZOOMBARASSLIDERCONTROL, &COSMCtrlAppView::OnUpdateViewDrawZoomBarAaSliderControl)
  ON_COMMAND(ID_VIEW_ALLOWDOUBLECLICKZOOM, &COSMCtrlAppView::OnViewAllowDoubleClickZoom)
  ON_UPDATE_COMMAND_UI(ID_VIEW_ALLOWDOUBLECLICKZOOM, &COSMCtrlAppView::OnUpdateViewAllowDoubleClickZoom)
  ON_COMMAND(ID_VIEW_REFRESHTILE, &COSMCtrlAppView::OnViewRefreshTile)
  ON_COMMAND(ID_DRAW_NORMAL, &COSMCtrlAppView::OnDrawNormal)
  ON_UPDATE_COMMAND_UI(ID_DRAW_NORMAL, &COSMCtrlAppView::OnUpdateDrawNormal)
  ON_COMMAND(ID_DRAW_POLYGON, &COSMCtrlAppView::OnDrawPolygon)
  ON_COMMAND(ID_DRAW_ROTATE, &COSMCtrlAppView::OnDrawRotate)
  ON_UPDATE_COMMAND_UI(ID_DRAW_ROTATE, &COSMCtrlAppView::OnUpdateDrawRotate)
  ON_UPDATE_COMMAND_UI(ID_DRAW_POLYGON, &COSMCtrlAppView::OnUpdateDrawPolygon)
  ON_COMMAND(ID_DRAW_POLYLINE, &COSMCtrlAppView::OnDrawPolyline)
  ON_UPDATE_COMMAND_UI(ID_DRAW_POLYLINE, &COSMCtrlAppView::OnUpdateDrawPolyline)
  ON_COMMAND(ID_DRAW_MARKER, &COSMCtrlAppView::OnDrawMarker)
  ON_UPDATE_COMMAND_UI(ID_DRAW_MARKER, &COSMCtrlAppView::OnUpdateDrawMarker)
  ON_COMMAND(ID_DRAW_SELECTIONRECTANGLE, &COSMCtrlAppView::OnDrawSelectionRectangle)
  ON_UPDATE_COMMAND_UI(ID_DRAW_SELECTIONRECTANGLE, &COSMCtrlAppView::OnUpdateDrawSelectionRectangle)
  ON_COMMAND(ID_VIEW_MAPOPERATIONS, &COSMCtrlAppView::OnViewMapOperations)
  ON_COMMAND(ID_DRAW_CIRCLE, &COSMCtrlAppView::OnDrawCircle)
  ON_UPDATE_COMMAND_UI(ID_DRAW_CIRCLE, &COSMCtrlAppView::OnUpdateDrawCircle)
  ON_UPDATE_COMMAND_UI(ID_VIEW_DRAWCENTERCROSSHAIRS, &COSMCtrlAppView::OnUpdateViewDrawCenterCrosshairs)
  ON_COMMAND(ID_VIEW_DRAWCENTERCROSSHAIRS, &COSMCtrlAppView::OnViewDrawCenterCrosshairs)
  ON_COMMAND(ID_VIEW_GPSSETTINGS, &COSMCtrlAppView::OnViewGPSSettings)
  ON_COMMAND(ID_VIEW_ALLOWANIMATIONS, &COSMCtrlAppView::OnViewAllowAnimations)
  ON_UPDATE_COMMAND_UI(ID_VIEW_ALLOWANIMATIONS, &COSMCtrlAppView::OnUpdateViewAllowAnimations)
  ON_COMMAND(ID_FILE_IMPORTGPXFILE, &COSMCtrlAppView::OnFileImportGPXFile)
  ON_COMMAND(ID_FILE_EXPORTGPXFILE, &COSMCtrlAppView::OnFileExportGPXFile)
  ON_COMMAND(ID_VIEW_ADDRESSLOOKUP, &COSMCtrlAppView::OnViewAddressLookup)
  ON_COMMAND(ID_VIEW_SEARCH, &COSMCtrlAppView::OnViewSearch)
  ON_COMMAND(ID_VIEW_GOTOCOORDINATES, &COSMCtrlAppView::OnViewGotoCoordinates)
  ON_COMMAND(ID_VIEW_SETTINGS, &COSMCtrlAppView::OnViewSettings)
#ifndef COSMCTRL_NOD2D
  ON_COMMAND(ID_VIEW_RESETMAPORIENTATION, &COSMCtrlAppView::OnViewResetMapOrientation)
#endif //#ifndef COSMCTRL_NOD2D
END_MESSAGE_MAP()


#pragma warning(suppress: 26455)
COSMCtrlAppView::COSMCtrlAppView() : m_nGPSPort{0},
                                     m_nGPSBaudRate{4800},
                                     m_GPSParity{GPSCom2::GPS_PARITY_NONE},
                                     m_nGPSDataBits{8},
                                     m_GPSStopBits{GPSCom2::GPS_1_STOP_BIT},
                                     m_bGPSCenter{true},
                                     m_bChangeBearingOfMap{false},
                                     m_bGPSFix{false},
                                     m_bSensor{false},
                                     m_bGPXTrackLog{false},
                                     m_nDefaultMarkerIconIndex{0},
                                     m_MapPointerMode{MapPointerMode::Undefined},
                                     m_SensorID{}
{
  CString sProxyServer;
  CString sProxyBypassList;
  const UINT nType{theApp.GetProfileInt(_T("General"), _T("ProxyServerType"), static_cast<int>(CSettingsDlg::ProxyServerType::UseSettingsFromIE))};
  switch (static_cast<CSettingsDlg::ProxyServerType>(nType))
  {
    case CSettingsDlg::ProxyServerType::UseSettingsFromIE:
    {
      WINHTTP_CURRENT_USER_IE_PROXY_CONFIG proxyConfig{};
      if (WinHttpGetIEProxyConfigForCurrentUser(&proxyConfig))
      {
        sProxyServer = proxyConfig.lpszProxy;
        sProxyBypassList = proxyConfig.lpszProxyBypass;

        //Free up the allocated memory
        if (proxyConfig.lpszAutoConfigUrl != nullptr)
          GlobalFree(proxyConfig.lpszAutoConfigUrl);
        if (proxyConfig.lpszProxy != nullptr)
          GlobalFree(proxyConfig.lpszProxy);
        if (proxyConfig.lpszProxyBypass != nullptr)
          GlobalFree(proxyConfig.lpszProxyBypass);
      }
      break;
    }
    case CSettingsDlg::ProxyServerType::DirectConnection:
    {
      //Nothing to do for this case
      break;
    }
    case CSettingsDlg::ProxyServerType::SpecificProxyServer:
    {
      sProxyServer = theApp.GetProfileString(_T("General"), _T("ProxyServer"), _T(""));
      sProxyBypassList = theApp.GetProfileString(_T("General"), _T("ProxyBypassList"), _T(""));
      break;
    }
    default:
    {
      ASSERT(false);
      break;
    }
  }

  m_ctrlOSM.SetProxyServer(sProxyServer);
  m_ctrlOSM.SetProxyBypassList(sProxyBypassList);
}

void COSMCtrlAppView::OnDraw(CDC* /*pDC*/) noexcept
{
  //Nothing to do
}

BOOL COSMCtrlAppView::OnPreparePrinting(CPrintInfo* pInfo)
{
  //Change some values before we delegate to DoPreparePrinting
#pragma warning(suppress: 26489)
  pInfo->m_pPD->m_pd.nMinPage = 1;
#pragma warning(suppress: 26489)
  pInfo->m_pPD->m_pd.nMaxPage = 1;
  return DoPreparePrinting(pInfo);
}

void COSMCtrlAppView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
  //Nothing to do
}

void COSMCtrlAppView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
  //Nothing to do
}

#ifdef _DEBUG
void COSMCtrlAppView::AssertValid() const
{
  __super::AssertValid();
}

void COSMCtrlAppView::Dump(CDumpContext& dc) const
{
  __super::Dump(dc);
}

#pragma warning(suppress: 26434)
COSMCtrlAppDoc* COSMCtrlAppView::GetDocument() const //non-debug version is inline
{
  ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COSMCtrlAppDoc)));
#pragma warning(suppress: 26466)
  return static_cast<COSMCtrlAppDoc*>(m_pDocument);
}
#endif //#ifdef _DEBUG

#ifdef COSMCTRL_NOD2D
HRESULT COSMCtrlAppView::LoadResourceImage(LPCTSTR pName, LPCTSTR pType, HMODULE hInst, std::shared_ptr<Gdiplus::Image>& image)
{
  //Find the resource
  HRSRC hResource{FindResource(hInst, pName, pType)};
  if (hResource == nullptr)
    return ATL::AtlHresultFromWin32(GetLastError());

  //Get the size of the resource
  const DWORD dwResourceSize{SizeofResource(hInst, hResource)};
  if (dwResourceSize == 0)
    return ATL::AtlHresultFromWin32(GetLastError());

  //Load up the resource
  HGLOBAL hImage{LoadResource(hInst, hResource)};
  if (hImage == nullptr)
    return ATL::AtlHresultFromWin32(GetLastError());
  LPVOID pImageData{LockResource(hImage)};
  if (pImageData == nullptr)
    return ATL::AtlHresultFromWin32(GetLastError());

  //What will be the return value from this function (assume the best)
  HRESULT hr{S_OK};

  //Create a buffer for the stream
  HGLOBAL hGlobal{GlobalAlloc(GMEM_MOVEABLE, dwResourceSize)};
  if (hGlobal)
  {
    LPVOID pGlobal{GlobalLock(hGlobal)};
    if (pGlobal)
    {
      //Transfer the resource to the buffer
      memcpy(pGlobal, pImageData, dwResourceSize);

      //Create the stream from the buffer
      ATL::CComPtr<IStream> pStream;
      hr = CreateStreamOnHGlobal(hGlobal, TRUE, &pStream);
      if (hr == S_OK)
        image.reset(Gdiplus::Image::FromStream(pStream));

      GlobalUnlock(hGlobal);
    }
    else
      hr = ATL::AtlHresultFromWin32(GetLastError());
  }
  else
    hr = ATL::AtlHresultFromWin32(GetLastError());

  return hr;
}
#endif //#ifdef COSMCTRL_NOD2D

#pragma warning(suppress: 26434)
int COSMCtrlAppView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  //Create the OSM ctrl
  CRect rClient;
  GetClientRect(&rClient);
  if (!m_ctrlOSM.Create(_T(""), WS_VISIBLE | WS_CHILD | WS_CLIPCHILDREN | SS_NOTIFY, rClient, this))
  {
    TRACE(_T("COSMCtrlAppView::OnCreate, Failed to create OSM window\n")); 
    return -1;
  }
  //Hook up the event handler
  m_ctrlOSM.SetEventHandler(this);

  //Lets use a cache in FOLDERID_LocalAppData\OSMCtrlApp\Provider
  PWSTR pwszCacheDirectory{nullptr};
#pragma warning(suppress: 26496)
  HRESULT hr{SHGetKnownFolderPath(FOLDERID_LocalAppData, KF_FLAG_DEFAULT, nullptr, &pwszCacheDirectory)};
  if (FAILED(hr))
  {
    TRACE(_T("COSMCtrlAppView::OnCreate, Failed to get FOLDERID_LocalAppData folder location\n")); 
    return -1;
  }
  CString sCacheDirectory{pwszCacheDirectory};
  CoTaskMemFree(pwszCacheDirectory);
  sCacheDirectory += _T("\\OSMCtrlApp");
  CreateDirectory(sCacheDirectory, nullptr);
  const auto tileProvider{static_cast<OSMCtrlAppTileProvider>(theApp.GetProfileInt(_T("General"), _T("TileProvider"), static_cast<int>(OSMCtrlAppTileProvider::Mapnik)))};
  switch (tileProvider)
  {
    case OSMCtrlAppTileProvider::Cyclemap:
    {
      m_ctrlOSM.SetTileProvider(&m_CyclemapTileProvider);
      sCacheDirectory += _T("\\Cyclemap");
      break;
    }
    case OSMCtrlAppTileProvider::Mapnik: //deliberate fallthrough
    default:
    {
      m_ctrlOSM.SetTileProvider(&m_MapnikTileProvider);
      sCacheDirectory += _T("\\Mapnik");
      break;
    }
  }
  CreateDirectory(sCacheDirectory, nullptr);
  m_ctrlOSM.SetCacheDirectory(sCacheDirectory);

  //As a convenience, restore the various settings
  CString sZoom;
  sZoom.Format(_T("%f"), m_ctrlOSM.GetZoom());
  sZoom = theApp.GetProfileString(_T("General"), _T("ZoomS"), sZoom);
  const double fZoom{_tstof(sZoom)};
  CString sDefault;
  const COSMCtrlPosition centerPosition{m_ctrlOSM.GetCenter()};
  sDefault.Format(_T("%f"), centerPosition.m_fLongitude);
  CString sValue{theApp.GetProfileString(_T("General"), _T("LastLongitude"), sDefault)};
  const double dLongitude{_tstof(sValue)};
  sDefault.Format(_T("%f"), centerPosition.m_fLatitude);
  sValue = theApp.GetProfileString(_T("General"), _T("LastLatitude"), sDefault);
  const double dLatitude{_tstof(sValue)};
#ifndef COSMCTRL_NOD2D
  sDefault.Format(_T("%f"), m_ctrlOSM.GetBearingOfTopOfMap());
  sValue = theApp.GetProfileString(_T("General"), _T("LastBearingAtTopOfMap"), sDefault);
  const double fBearingAtTopOfMap{_tstof(sValue)};
#else
  constexpr const double fBearingAtTopOfMap{0};
#endif //#ifndef COSMCTRL_NOD2D
  m_ctrlOSM.SetCenterAndZoomAndBearing(COSMCtrlPosition{dLongitude, dLatitude}, fZoom, fBearingAtTopOfMap, m_ctrlOSM.GetDefaultAnimationDuration());
  m_ctrlOSM.SetDrawScrollRose(theApp.GetProfileInt(_T("General"), _T("DrawScrollRose"), TRUE));
  m_ctrlOSM.SetDrawZoomBar(theApp.GetProfileInt(_T("General"), _T("DrawZoomBar"), TRUE));
  m_ctrlOSM.SetDrawScaleBar(theApp.GetProfileInt(_T("General"), _T("DrawScaleBar"), TRUE));
  m_ctrlOSM.SetUseTransparencyForZoomBar(theApp.GetProfileInt(_T("General"), _T("UseTransparencyForZoomBar"), TRUE));
  m_ctrlOSM.SetDrawTileOutlines(theApp.GetProfileInt(_T("General"), _T("DrawTileOutlines"), FALSE));
  m_ctrlOSM.SetDownloadTiles(theApp.GetProfileInt(_T("General"), _T("DownloadTiles"), TRUE));
  m_ctrlOSM.SetAllowUseNextZoomSqueeze(theApp.GetProfileInt(_T("General"), _T("UseNextZoomSqueeze"), TRUE));
  m_ctrlOSM.SetAllowUsePreviousZoomStretch(theApp.GetProfileInt(_T("General"), _T("UsePrevZoomStretch"), TRUE));
  m_ctrlOSM.SetDrawZoomBarAsSlider(theApp.GetProfileInt(_T("General"), _T("DrawZoomBarAsSlider"), TRUE));
  m_ctrlOSM.SetDrawCenterCrossHairs(theApp.GetProfileInt(_T("General"), _T("DrawCenterCrossHairs"), TRUE));
  m_bGPXTrackLog = theApp.GetProfileInt(_T("General"), _T("GPXTrackLog"), m_bGPXTrackLog);
  LoadTrackLog();

  //Load up the default icon to use for markers
  m_ctrlOSM.m_Icons.push_back(&m_dummyDefaultIcon);
  m_nDefaultMarkerIconIndex = m_ctrlOSM.m_Icons.size() - 1;
#ifdef COSMCTRL_NOD2D
  hr = LoadResourceImage(MAKEINTRESOURCE(IDB_DEFAULT_MARKER), _T("PNG"), AfxGetResourceHandle(), m_dummyDefaultIcon.m_Image);
  if (FAILED(hr))
  {
    TRACE(_T("COSMCtrlAppView::OnCreate, Failed to load up icon1.png resource\n")); 
    return -1;
  }
#else
  m_dummyDefaultIcon.m_nResourceID = IDB_DEFAULT_MARKER;
  m_dummyDefaultIcon.m_sResourceType = _T("PNG");
#endif //#ifdef COSMCTRL_NOD2D
  //Set the anchor position of the icon to be the bottom of pin
  m_dummyDefaultIcon.m_ptAnchor.x = 10;
  m_dummyDefaultIcon.m_ptAnchor.y = 24;

#ifdef _DEBUG  //For demonstration purposes, lets add some objects to the map if we are running a debug build
  auto coWexfordMarker{std::make_shared<COSMCtrlMarker>()};
  coWexfordMarker->m_Position = std::move(COSMCtrlPosition{-6.59, 52.42});
  coWexfordMarker->m_sToolTipText = _T("The author PJ lives somewhere in County Wexford, Ireland!. You can drag me!");
  coWexfordMarker->m_nIconIndex = m_nDefaultMarkerIconIndex;
  coWexfordMarker->m_nMinZoomLevel = 0;
  coWexfordMarker->m_nMaxZoomLevel = 10;
  coWexfordMarker->m_bDraggable = true; //Allow the marker to be draggable
  m_ctrlOSM.m_Markers.push_back(coWexfordMarker);

  //For demonstration purposes, lets add a polyline to the map
  auto samplePolyline{std::make_shared<COSMCtrlPolyline>()};
  samplePolyline->m_Nodes.emplace_back(-7.5, 54);
  samplePolyline->m_Nodes.emplace_back(-9, 55);
  samplePolyline->m_Nodes.emplace_back(-8, 51);
  samplePolyline->m_Nodes.emplace_back(-7, 52);
  samplePolyline->m_fDashOffset = 3;
#ifdef COSMCTRL_NOD2D
  samplePolyline->m_DashCap = Gdiplus::DashCapRound;
  samplePolyline->m_DashStyle = Gdiplus::DashStyleDot;
  samplePolyline->m_EndCap = Gdiplus::LineCapSquareAnchor;
  samplePolyline->m_StartCap = Gdiplus::LineCapArrowAnchor;
  samplePolyline->m_LineJoin = Gdiplus::LineJoinBevel;
#else
  samplePolyline->m_DashCap = D2D1_CAP_STYLE_ROUND;
  samplePolyline->m_DashStyle = D2D1_DASH_STYLE_DOT;
  samplePolyline->m_EndCap = D2D1_CAP_STYLE_SQUARE;
  samplePolyline->m_StartCap = D2D1_CAP_STYLE_TRIANGLE;
  samplePolyline->m_LineJoin = D2D1_LINE_JOIN_BEVEL;
#endif //#ifdef COSMCTRL_NOD2D
  samplePolyline->m_nMinZoomLevel = 0;
  samplePolyline->m_nMaxZoomLevel = 18;
  samplePolyline->m_sToolTipText = _T("A simple Polyline example for COSMCtrl");
  samplePolyline->m_bDraggable = true;
  samplePolyline->m_bEditable = true;
  samplePolyline->m_fLinePenWidth = 5;
#pragma warning(suppress: 26486)
  m_ctrlOSM.m_Polylines.push_back(samplePolyline);

  //For demonstration purposes, lets add a polygon to the map
  auto samplePolygon{std::make_shared<COSMCtrlPolygon>()};
  samplePolygon->m_Nodes.emplace_back(-4, 52);
  samplePolygon->m_Nodes.emplace_back(0, 51);
  samplePolygon->m_Nodes.emplace_back(-1, 59);
  samplePolygon->m_Nodes.emplace_back(-8, 56);
#ifdef COSMCTRL_NOD2D
  samplePolygon->m_DashCap = Gdiplus::DashCapRound;
  samplePolygon->m_EndCap = Gdiplus::LineCapSquareAnchor;
  samplePolygon->m_StartCap = Gdiplus::LineCapArrowAnchor;
  samplePolygon->m_LineJoin = Gdiplus::LineJoinBevel;
#else
  samplePolygon->m_DashCap = D2D1_CAP_STYLE_ROUND;
  samplePolygon->m_EndCap = D2D1_CAP_STYLE_SQUARE;
  samplePolygon->m_StartCap = D2D1_CAP_STYLE_TRIANGLE;
  samplePolygon->m_LineJoin = D2D1_LINE_JOIN_BEVEL;
#endif //#ifdef COSMCTRL_NOD2D
  samplePolygon->m_fDashOffset = 3;
  samplePolygon->m_fLinePenWidth = 5;
  samplePolygon->m_nMinZoomLevel = 0;
  samplePolygon->m_nMaxZoomLevel = 18;
  samplePolygon->m_sToolTipText = _T("A simple Polygon example for COSMCtrl");
  samplePolygon->m_bDraggable = true;
  samplePolygon->m_bEditable = true;
  m_ctrlOSM.m_Polygons.push_back(samplePolygon);

  //For demonstration purposes, lets add a circle to the map
  auto sampleCircle{std::make_shared<COSMCtrlCircle>()};
  sampleCircle->m_Position = std::move(COSMCtrlPosition{2, 49});
  sampleCircle->m_fRadius = 200000;
#ifdef COSMCTRL_NOD2D
  sampleCircle->m_DashStyle = Gdiplus::DashStyleDashDot;
#else
  sampleCircle->m_DashStyle = D2D1_DASH_STYLE_DASH_DOT;
#endif //#ifdef COSMCTRL_NOD2D
  sampleCircle->m_fLinePenWidth = 5;
  sampleCircle->m_nMinZoomLevel = 0;
  sampleCircle->m_nMaxZoomLevel = 18;
  sampleCircle->m_sToolTipText = _T("A simple Circle example for COSMCtrl");
  sampleCircle->m_bDraggable = true;
  sampleCircle->m_bEditable = true;
  m_ctrlOSM.m_Circles.push_back(sampleCircle);
#endif //#ifdef _DEBUG

  //Read in the GPS settings and start it up if required
  m_nGPSPort = theApp.GetProfileInt(_T("GPS"), _T("Port"), m_nGPSPort);
  m_nGPSBaudRate = theApp.GetProfileInt(_T("GPS"), _T("BaudRate"), m_nGPSBaudRate);
  m_GPSParity = static_cast<GPSCom2::GPS_PARITY>(theApp.GetProfileInt(_T("GPS"), _T("Parity"), m_GPSParity));
  m_nGPSDataBits = theApp.GetProfileInt(_T("GPS"), _T("DataBits"), m_nGPSDataBits);
  m_GPSStopBits = static_cast<GPSCom2::GPS_STOP_BITS>(theApp.GetProfileInt(_T("GPS"), _T("StopBits"), m_GPSStopBits));
  m_bGPSCenter = theApp.GetProfileInt(_T("GPS"), _T("Center"), m_bGPSCenter);
  m_bSensor = theApp.GetProfileInt(_T("GPS"), _T("Sensor"), m_bSensor);
  m_bChangeBearingOfMap = theApp.GetProfileInt(_T("GPS"), _T("ChangeBearingOfMap"), m_bChangeBearingOfMap);

  //Startup GPS if required
  OpenGPS(false);

  return 0;
}

#pragma warning(suppress: 26434)
void COSMCtrlAppView::OnSize(UINT nType, int cx, int cy)
{
  //Let the base class do its thing
  __super::OnSize(nType, cx, cy);

  //Always make the OSM ctrl fill the full client area
  CRect rClient;
  GetClientRect(&rClient);
  m_ctrlOSM.MoveWindow(rClient);
}

#pragma warning(suppress: 26434 26440)
BOOL COSMCtrlAppView::OnEraseBkgnd(CDC* /*pDC*/)
{
  //Avoid flicker by doing nothing
  return TRUE;
}

void COSMCtrlAppView::OnZoom0()
{
  m_ctrlOSM.SetZoom(0, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom1()
{
  m_ctrlOSM.SetZoom(1, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom2()
{
  m_ctrlOSM.SetZoom(2, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom3()
{
  m_ctrlOSM.SetZoom(3, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom4()
{
  m_ctrlOSM.SetZoom(4, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom5()
{
  m_ctrlOSM.SetZoom(5, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom6()
{
  m_ctrlOSM.SetZoom(6, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom7()
{
  m_ctrlOSM.SetZoom(7, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom8()
{
  m_ctrlOSM.SetZoom(8, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom9()
{
  m_ctrlOSM.SetZoom(9, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom10()
{
  m_ctrlOSM.SetZoom(10, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom11()
{
  m_ctrlOSM.SetZoom(11, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom12()
{
  m_ctrlOSM.SetZoom(12, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom13()
{
  m_ctrlOSM.SetZoom(13, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom14()
{
  m_ctrlOSM.SetZoom(14, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom15()
{
  m_ctrlOSM.SetZoom(15, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom16()
{
  m_ctrlOSM.SetZoom(16, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom17()
{
  m_ctrlOSM.SetZoom(17, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoom18()
{
  m_ctrlOSM.SetZoom(18, m_ctrlOSM.GetDefaultAnimationDuration());
}

void COSMCtrlAppView::OnZoomToSelection()
{
  COSMCtrlPosition topLeftSelection;
  COSMCtrlPosition bottomRightSelection;
  if (!m_ctrlOSM.m_SelectionPolygon->GetBoundingRect(topLeftSelection, bottomRightSelection))
    return;
  m_ctrlOSM.ZoomToBounds(topLeftSelection, bottomRightSelection, m_ctrlOSM.GetDefaultAnimationDuration());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom0(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 0);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom1(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 1);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 2);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom3(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 3);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom4(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 4);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom5(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 5);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom6(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 6);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom7(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 7);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom8(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 8);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom9(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 9);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom10(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 10);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom11(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 11);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom12(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 12);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom13(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 13);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom14(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 14);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom15(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 15);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom16(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 16);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom17(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 17);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoom18(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetZoom() == 18);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateZoomToSelection(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(m_ctrlOSM.m_SelectionPolygon->m_Nodes.size() != 0);
}

#pragma warning(suppress: 26434)
void COSMCtrlAppView::OnSetFocus(CWnd* /*pOldWnd*/)
{
  //Always give focus to the OSM window if we get focus
  m_ctrlOSM.SetFocus();
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAutoDownloadTiles(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDownloadTiles());
}

void COSMCtrlAppView::OnViewAutoDownloadTiles()
{
  m_ctrlOSM.SetDownloadTiles(!m_ctrlOSM.GetDownloadTiles());
}

void COSMCtrlAppView::OnProvidersMapnik()
{
  //Change the cache directory when we change tile provider
  PWSTR pwszCacheDirectory{nullptr};
  const HRESULT hr{SHGetKnownFolderPath(FOLDERID_LocalAppData, KF_FLAG_DEFAULT, nullptr, &pwszCacheDirectory)};
  if (FAILED(hr))
  {
    TRACE(_T("COSMCtrlAppView::OnProvidersMapnik, Failed to get FOLDERID_LocalAppData folder location\n")); 
    return;
  }
  CString sCacheDirectory{pwszCacheDirectory};
  CoTaskMemFree(pwszCacheDirectory);
  sCacheDirectory += _T("\\OSMCtrlApp\\Mapnik");
  CreateDirectory(sCacheDirectory, nullptr);
  m_ctrlOSM.SetCacheDirectory(sCacheDirectory);

  //Then change the tile provider
  m_ctrlOSM.SetTileProvider(&m_MapnikTileProvider);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateProvidersMapnik(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetTileProvider() == &m_MapnikTileProvider);
}

#pragma warning(suppress: 26434)
void COSMCtrlAppView::OnDestroy()
{
  //Remember the various settings
  CString sZoom;
  sZoom.Format(_T("%f"), m_ctrlOSM.GetZoom());
  theApp.WriteProfileString(_T("General"), _T("ZoomS"), sZoom);
  CString sValue;
  const COSMCtrlPosition centerPosition{m_ctrlOSM.GetCenter()};
  sValue.Format(_T("%f"), centerPosition.m_fLongitude);
  theApp.WriteProfileString(_T("General"), _T("LastLongitude"), sValue);
  sValue.Format(_T("%f"), centerPosition.m_fLatitude);
  theApp.WriteProfileString(_T("General"), _T("LastLatitude"), sValue);
#ifndef COSMCTRL_NOD2D
  CString sBearingAtTopOfMap;
  sBearingAtTopOfMap.Format(_T("%f"), m_ctrlOSM.GetBearingOfTopOfMap());
  theApp.WriteProfileString(_T("General"), _T("LastBearingAtTopOfMap"), sBearingAtTopOfMap);
#endif //#ifndef COSMCTRL_NOD2D
  const IOSMCtrlTileProvider* pTileProvider{m_ctrlOSM.GetTileProvider()};
  OSMCtrlAppTileProvider tileProvider{OSMCtrlAppTileProvider::Mapnik};
  if (pTileProvider == &m_CyclemapTileProvider)
    tileProvider = OSMCtrlAppTileProvider::Cyclemap;
  theApp.WriteProfileInt(_T("General"), _T("TileProvider"), static_cast<int>(tileProvider));
  theApp.WriteProfileInt(_T("General"), _T("DrawScrollRose"), m_ctrlOSM.GetDrawScrollRose());
  theApp.WriteProfileInt(_T("General"), _T("DrawZoomBar"), m_ctrlOSM.GetDrawZoomBar());
  theApp.WriteProfileInt(_T("General"), _T("DrawScaleBar"), m_ctrlOSM.GetDrawScaleBar());
  theApp.WriteProfileInt(_T("General"), _T("UseTransparencyForZoomBar"), m_ctrlOSM.GetUseTransparencyForZoomBar());
  theApp.WriteProfileInt(_T("General"), _T("DrawTileOutlines"), m_ctrlOSM.GetDrawTileOutlines());
  theApp.WriteProfileInt(_T("General"), _T("DownloadTiles"), m_ctrlOSM.GetDownloadTiles());
  theApp.WriteProfileInt(_T("General"), _T("UseNextZoomSqueeze"), m_ctrlOSM.GetAllowUseNextZoomSqueeze());
  theApp.WriteProfileInt(_T("General"), _T("UsePrevZoomStretch"), m_ctrlOSM.GetAllowUsePreviousZoomStretch());
  theApp.WriteProfileInt(_T("General"), _T("DrawZoomBarAsSlider"), m_ctrlOSM.GetDrawZoomBarAsSlider());
  theApp.WriteProfileInt(_T("General"), _T("DrawCenterCrossHairs"), m_ctrlOSM.GetDrawCenterCrossHairs());
  theApp.WriteProfileInt(_T("GPS"), _T("Port"), m_nGPSPort);
  theApp.WriteProfileInt(_T("GPS"), _T("BaudRate"), m_nGPSBaudRate);
  theApp.WriteProfileInt(_T("GPS"), _T("Parity"), m_GPSParity);
  theApp.WriteProfileInt(_T("GPS"), _T("DataBits"), m_nGPSDataBits);
  theApp.WriteProfileInt(_T("GPS"), _T("StopBits"), m_GPSStopBits);
  theApp.WriteProfileInt(_T("GPS"), _T("Center"), m_bGPSCenter);
  theApp.WriteProfileInt(_T("General"), _T("GPXTrackLog"), m_bGPXTrackLog);
  theApp.WriteProfileInt(_T("GPS"), _T("Sensor"), m_bSensor);
  theApp.WriteProfileInt(_T("GPS"), _T("ChangeBearingOfMap"), m_bChangeBearingOfMap);

  //Do the final save of the track log if necessary
  CString sTrackLogFilename;
  if (GetTrackLogFilename(sTrackLogFilename))
    SaveTrackLog(sTrackLogFilename);

  //Make sure the sensor is closed down before we close
  m_Sensor.Release();

  //Let the base class do its thing
  __super::OnDestroy();
}

void COSMCtrlAppView::OnViewClearCache()
{
  CWaitCursor wait;
  m_ctrlOSM.SetCacheDirectory(m_ctrlOSM.GetCacheDirectory(), true);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateProvidersCyclemap(CCmdUI *pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetTileProvider() == &m_CyclemapTileProvider);
}

void COSMCtrlAppView::OnProvidersCyclemap()
{
  //Change the cache directory when we change tile provider
  PWSTR pwszCacheDirectory{nullptr};
  const HRESULT hr{SHGetKnownFolderPath(FOLDERID_LocalAppData, KF_FLAG_DEFAULT, nullptr, &pwszCacheDirectory)};
  if (FAILED(hr))
  {
    TRACE(_T("COSMCtrlAppView::OnProvidersCyclemap, Failed to get FOLDERID_LocalAppData folder location\n")); 
    return;
  }
  CString sCacheDirectory{pwszCacheDirectory};
  CoTaskMemFree(pwszCacheDirectory);
  sCacheDirectory += _T("\\OSMCtrlApp\\Cyclemap");
  CreateDirectory(sCacheDirectory, nullptr);
  m_ctrlOSM.SetCacheDirectory(sCacheDirectory);

  m_ctrlOSM.SetTileProvider(&m_CyclemapTileProvider);
}

void COSMCtrlAppView::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
  //Validate our parameters
#pragma warning(suppress: 26496)
  AFXASSUME(pInfo != nullptr);

  //let the Draw method do the work
  CRect rClient;
  GetClientRect(&rClient);

  //Work out the scaling factor to use
  ASSERT(pInfo != nullptr);
  const int nClientWidth{rClient.Width()};
  const double dXScale{pInfo->m_rectDraw.Width() / (nClientWidth + 0.0)};
  const int nClientHeight{rClient.Height()};
  const double dYScale{pInfo->m_rectDraw.Height() / (nClientHeight + 0.0)};
  const double dScale{min(dXScale, dYScale)};
  const CRect rDest{pInfo->m_rectDraw.left, pInfo->m_rectDraw.top, pInfo->m_rectDraw.left + static_cast<int>((nClientWidth * dScale)), pInfo->m_rectDraw.top + static_cast<int>((nClientHeight * dScale))};

  //Delegate all the work to the Draw method (Note we explicitly hide the scroll rose and zoom bar when we are printing)
#ifndef COSMCTRL_NOD2D
  m_ctrlOSM.DestroyD2DResources();
#endif //#ifndef COSMCTRL_NOD2D
  m_ctrlOSM.Draw(pDC, &rClient, &rDest, false, false, m_ctrlOSM.GetDrawScaleBar());
#ifndef COSMCTRL_NOD2D
  m_ctrlOSM.DestroyD2DResources();
#endif //#ifndef COSMCTRL_NOD2D
}

void COSMCtrlAppView::OnViewRefresh()
{
  //Ask the control to refresh itself
  m_ctrlOSM.Refresh();
}

void COSMCtrlAppView::OnViewDrawScrollRose()
{
  m_ctrlOSM.SetDrawScrollRose(!m_ctrlOSM.GetDrawScrollRose());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewDrawScrollRose(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDrawScrollRose());
}

void COSMCtrlAppView::OnViewDrawZoomBar()
{
  m_ctrlOSM.SetDrawZoomBar(!m_ctrlOSM.GetDrawZoomBar());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewDrawZoomBar(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDrawZoomBar());
}

void COSMCtrlAppView::OnViewAllowDrag() noexcept
{
  m_ctrlOSM.SetAllowDrag(!m_ctrlOSM.GetAllowDrag());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAllowDrag(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetAllowDrag());
}

void COSMCtrlAppView::OnViewAllowKeyboard() noexcept
{
  m_ctrlOSM.SetAllowKeyboard(!m_ctrlOSM.GetAllowKeyboard());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAllowKeyboard(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetAllowKeyboard());
}

void COSMCtrlAppView::OnViewAllowMouseZoom() noexcept
{
  m_ctrlOSM.SetAllowMouseZoom(!m_ctrlOSM.GetAllowMouseZoom());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAllowMouseZoom(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetAllowMouseZoom());
}

void COSMCtrlAppView::OnViewDrawScaleBar()
{
  m_ctrlOSM.SetDrawScaleBar(!m_ctrlOSM.GetDrawScaleBar());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewDrawScaleBar(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDrawScaleBar());
}

void COSMCtrlAppView::OnViewAllowPreviousZoomStretch() noexcept
{
  m_ctrlOSM.SetAllowUsePreviousZoomStretch(!m_ctrlOSM.GetAllowUsePreviousZoomStretch());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAllowPreviousZoomStretch(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetAllowUsePreviousZoomStretch());
}

void COSMCtrlAppView::OnViewAllowNextZoomSqueeze() noexcept
{
  m_ctrlOSM.SetAllowUseNextZoomSqueeze(!m_ctrlOSM.GetAllowUseNextZoomSqueeze());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAllowNextZoomSqueeze(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetAllowUseNextZoomSqueeze());
}

void COSMCtrlAppView::OnViewDownloadTilesFromCenterOutwards() noexcept
{
  if (m_ctrlOSM.GetDownloadOrder() == COSMCtrl::DownloadOrder::ClosestToCenterFirst)
    m_ctrlOSM.SetDownloadOrder(COSMCtrl::DownloadOrder::YOuterXInnerLeftToRight);
  else
    m_ctrlOSM.SetDownloadOrder(COSMCtrl::DownloadOrder::ClosestToCenterFirst);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewDownloadTilesFromCenterOutwards(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDownloadOrder() == COSMCtrl::DownloadOrder::ClosestToCenterFirst);
}

void COSMCtrlAppView::OnViewUseTransparencyforZoomBar()
{
  m_ctrlOSM.SetUseTransparencyForZoomBar(!m_ctrlOSM.GetUseTransparencyForZoomBar());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewUseTransparencyForZoomBar(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetUseTransparencyForZoomBar());
}

void COSMCtrlAppView::OnViewDrawTileOutlines()
{
  m_ctrlOSM.SetDrawTileOutlines(!m_ctrlOSM.GetDrawTileOutlines());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewDrawTileOutlines(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDrawTileOutlines());
}

#ifndef COSMCTRL_NOD2D
void COSMCtrlAppView::OnViewResetMapOrientation()
{
  m_ctrlOSM.SetBearingOfTopOfMap(0.0, 0.0);
}
#endif

#pragma warning(suppress: 26434)
void COSMCtrlAppView::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
  if ((point.x == -1) && (point.y == -1))
  {
    //keystroke invocation, in this case get the position underneath the cursor
    GetCursorPos(&point);
  }

  //Display a context menu to allow operations on the tile underneath
  CMenu menu;
  VERIFY(menu.LoadMenu(IDR_POPUP_VIEW));

  CMenu* pPopup{menu.GetSubMenu(0)};
#pragma warning(suppress: 26496)
  AFXASSUME(pPopup != nullptr);

  //Get the right owner window for the menu
#pragma warning(suppress: 26429)
  CWnd* pWndPopupOwner{this};
  while (pWndPopupOwner->GetStyle() & WS_CHILD)
    pWndPopupOwner = pWndPopupOwner->GetParent();

#pragma warning(suppress: 26486)
  pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, pWndPopupOwner);
}

void COSMCtrlAppView::OnViewDrawZoomBarAaSliderControl()
{
  m_ctrlOSM.SetDrawZoomBarAsSlider(!m_ctrlOSM.GetDrawZoomBarAsSlider());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewDrawZoomBarAaSliderControl(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDrawZoomBarAsSlider());
}

void COSMCtrlAppView::OnViewAllowDoubleClickZoom() noexcept
{
  m_ctrlOSM.SetAllowDoubleClickZoom(!m_ctrlOSM.GetAllowDoubleClickZoom());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAllowDoubleClickZoom(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetAllowDoubleClickZoom());
}

void COSMCtrlAppView::OnDrawNormal()
{
  m_ctrlOSM.SetMapMode(COSMCtrl::MapMode::Normal);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateDrawNormal(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetMapMode() == COSMCtrl::MapMode::Normal);
}

void COSMCtrlAppView::OnDrawPolygon()
{
  m_ctrlOSM.SetMapMode(COSMCtrl::MapMode::PolygonCreation);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateDrawPolygon(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetMapMode() == COSMCtrl::MapMode::PolygonCreation);
}

void COSMCtrlAppView::OnDrawPolyline()
{
  m_ctrlOSM.SetMapMode(COSMCtrl::MapMode::PolylineCreation);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateDrawPolyline(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetMapMode() == COSMCtrl::MapMode::PolylineCreation);
}

void COSMCtrlAppView::OnDrawMarker()
{
  m_ctrlOSM.SetMapMode(COSMCtrl::MapMode::MarkerCreation);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateDrawMarker(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetMapMode() == COSMCtrl::MapMode::MarkerCreation);
}

void COSMCtrlAppView::OnDrawSelectionRectangle()
{
  m_ctrlOSM.SetMapMode(COSMCtrl::MapMode::Selection);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateDrawSelectionRectangle(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetMapMode() == COSMCtrl::MapMode::Selection);
}

void COSMCtrlAppView::OnDrawRotate()
{
  m_ctrlOSM.SetMapMode(COSMCtrl::MapMode::Rotate);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateDrawRotate(CCmdUI* pCmdUI)
{
#ifdef COSMCTRL_NOD2D
#pragma warning(suppress: 26486)
  pCmdUI->Enable(FALSE);
#else
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetMapMode() == COSMCtrl::MapMode::Rotate);
#endif //#ifdef COSMCTRL_NOD2D
}

void COSMCtrlAppView::OnViewMapOperations()
{
  COSMCtrlMapOperationsDlg dlg{this};
  m_ctrlOSM.ShowOperationsDialog(dlg);
}

void COSMCtrlAppView::OnDrawCircle()
{
  m_ctrlOSM.SetMapMode(COSMCtrl::MapMode::CircleCreation);
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateDrawCircle(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetMapMode() == COSMCtrl::MapMode::CircleCreation);
}

void COSMCtrlAppView::OnViewDrawCenterCrosshairs()
{
  m_ctrlOSM.SetDrawCenterCrossHairs(!m_ctrlOSM.GetDrawCenterCrossHairs());
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewDrawCenterCrosshairs(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDrawCenterCrossHairs());
}

void COSMCtrlAppView::ReportCOMError(_In_ HRESULT hr, _In_ const CString& sTemplate)
{
  //Report the error
  CString sErrorDescription;
  ATL::CComPtr<IErrorInfo> pError;
#pragma warning(suppress: 26477)
  if (SUCCEEDED(GetErrorInfo(0, &pError)) && pError)
  {
    CComBSTR bstrDescription;
    pError->GetDescription(&bstrDescription);
    sErrorDescription = bstrDescription;
  }
  CString sError;
  if (sErrorDescription.GetLength())
    sError.Format(_T("%s, Error:%08X, %s"), sTemplate.GetString(), hr, sErrorDescription.GetString());
  else
    sError.Format(_T("%s, Error:%08X"), sTemplate.GetString(), hr);

  AfxMessageBox(sError, MB_OK | MB_ICONSTOP);
}

void COSMCtrlAppView::OpenGPS(_In_ bool bReportError)
{
  //Close down the GPS connection
  Close();
  m_Sensor.Release();

  if (m_nGPSPort != 0)
  {
    if (m_bSensor)
    {
      //Instantiate the sensor manager on the local machine
      SensorAPI::CSensorManager<> manager;
      HRESULT hr{manager.Initialize()};
      if (FAILED(hr))
      { 
        if (bReportError)
          ReportCOMError(hr, _T("Could not create the Sensor Manager. Please make sure you are running on Windows 7 or later"));
        return;
      }

      //Get all the GPS sensors on the local machine
      ATL::CComPtr<ISensorCollection> sensorCollection;
      hr = manager->GetSensorsByType(SENSOR_TYPE_LOCATION_GPS, &sensorCollection);
      if (FAILED(hr))
      {
        if (bReportError)
          ReportCOMError(hr, _T("Could not find any GPS sensors on this machine"));
        return;
      }

      //Pull out the sensor we need
      hr = sensorCollection->GetAt(m_nGPSPort - 1, &m_Sensor); //If we are using a Sensor, then m_nGPSPort is +1 of the sensor index
      if (FAILED(hr))
      {
        if (bReportError)
          ReportCOMError(hr, _T("Could not connect to specified GPS sensor"));
        return;
      }

      //Cache the SensorID value
      hr = m_Sensor->GetID(&m_SensorID);
      if (FAILED(hr))
      {
        if (bReportError)
          ReportCOMError(hr, _T("Could not obtain id of specified GPS sensor"));
        return;
      }

      //Lets check to make sure it is not disabled and if so request permission to use this sensor
      SensorState state;
      hr = m_Sensor->GetState(&state);
      if (SUCCEEDED(hr) && (state == SENSOR_STATE_ACCESS_DENIED))
      {
        if (bReportError)
        {
          //Request permission to use this sensor
          hr = manager->RequestPermissions(GetSafeHwnd(), sensorCollection, TRUE);
          if ((hr == HRESULT_FROM_WIN32(ERROR_ACCESS_DENIED)) || (hr == HRESULT_FROM_WIN32(ERROR_CANCELLED))) 
          {
            AfxMessageBox(_T("Please use the Location and Other Sensors control panel to enable your GPS sensor and run this program again"), MB_OK | MB_ICONSTOP);
            return;
          }
        }
      }

      //Hook up events for the sensor
      hr = m_Sensor.SetEventSink();
      if (FAILED(hr))
      {
        if (bReportError)
          ReportCOMError(hr, _T("Could not hook up GPS sensor event sink"));
        return;
      }
    }
    else
    {
      //Reopen the GPS connection if necessary
      const HRESULT hr{Open(m_nGPSPort, m_nGPSBaudRate, m_GPSParity, m_nGPSDataBits, m_GPSStopBits)};
      if (FAILED(hr))
      {
        if (bReportError)
        {
          //Report the error
          CString sErrorDescription;
          ATL::CComPtr<IErrorInfo> pError;
#pragma warning(suppress: 26477)
          if (SUCCEEDED(GetErrorInfo(0, &pError)) && pError)
          {
            CComBSTR bstrDescription;
            pError->GetDescription(&bstrDescription);
            sErrorDescription = bstrDescription;
          }
          CString sError;
          if (hr == REGDB_E_CLASSNOTREG)
            sError = _T("The GPSCom2 component which is used to support GPS functionality is not registered on this computer. Please download GPSCom2 from http://www.naughter.com/gpscom2.html and register the binary using the command line \"GPSCom2.exe /RegServer\" from a command prompt (Elevated if running using UAC)");
          else if (sErrorDescription.GetLength())
            sError.Format(_T("%08X, %s"), hr, sErrorDescription.GetString());
          else
            sError.Format(_T("%08X"), hr);
          CString sMessage;
          AfxFormatString1(sMessage, IDS_FAIL_OPEN_GPS, sError);
          AfxMessageBox(sMessage, MB_OK | MB_ICONSTOP);
        }
      }
    }
  }
}

void COSMCtrlAppView::OnViewGPSSettings()
{
  CGPSSettingsDlg dlg;

  //Setup the current values
  dlg.m_nPort = m_nGPSPort;
  dlg.m_nBaudRate = m_nGPSBaudRate;
  dlg.m_nParity = m_GPSParity;
  dlg.m_nDataBits = m_nGPSDataBits;
  dlg.m_nStopBits = m_GPSStopBits;
  dlg.m_nGPSCenter = m_bGPSCenter;
  dlg.m_bGPXTrackLog = m_bGPXTrackLog;
  dlg.m_bSensor = m_bSensor;
  dlg.m_bChangeBearingOfMap = m_bChangeBearingOfMap;

  //Show the dialog
  if (dlg.DoModal() == IDOK)
  {
    //Save the new values to our member variables
    m_nGPSPort = dlg.m_nPort;
    m_nGPSBaudRate = dlg.m_nBaudRate;
    m_GPSParity = static_cast<GPSCom2::GPS_PARITY>(dlg.m_nParity);
    m_nGPSDataBits = dlg.m_nDataBits;
    m_GPSStopBits = static_cast<GPSCom2::GPS_STOP_BITS>(dlg.m_nStopBits);
    m_bGPSCenter = (dlg.m_nGPSCenter != 0);
    m_bSensor = dlg.m_bSensor;
    m_bChangeBearingOfMap = dlg.m_bChangeBearingOfMap;

    //Save the track log if we have just turned it off
    CString sTrackLogFilename;
    if (m_bGPXTrackLog && !dlg.m_bGPXTrackLog && GetTrackLogFilename(sTrackLogFilename))
      SaveTrackLog(sTrackLogFilename);

    m_bGPXTrackLog = dlg.m_bGPXTrackLog;

    //Empty out the GPS tracks in the control
    m_ctrlOSM.m_GPSTrack->m_Nodes.clear();

    //Force a redraw of the map
    m_ctrlOSM.Invalidate(FALSE);

    //Restart GPS if necessary
    OpenGPS(true);
  }
}

bool COSMCtrlAppView::GetTrackLogFilename(CString& sFileName)
{
  //Lets store the GPX files in FOLDERID_LocalAppData\OSMCtrlApp\GPX
  PWSTR pwszCacheDirectory{nullptr};
  const HRESULT hr{SHGetKnownFolderPath(FOLDERID_LocalAppData, KF_FLAG_DEFAULT, nullptr, &pwszCacheDirectory)};
  if (FAILED(hr))
  {
    TRACE(_T("COSMCtrlAppView::GetTrackLogFilename, Failed to get FOLDERID_LocalAppData folder location\n")); 
    return false;
  }
  CString sDirectory{pwszCacheDirectory};
  CoTaskMemFree(pwszCacheDirectory);
  sDirectory += _T("\\OSMCtrlApp");
  CreateDirectory(sDirectory, nullptr);
  sDirectory += _T("\\GPX");
  CreateDirectory(sDirectory, nullptr);

  //Create the name of the GPX file we will use
  SYSTEMTIME st;
  GetLocalTime(&st);
  sFileName.Format(_T("%s\\%04d%02d%02d.gpx"), sDirectory.GetString(), static_cast<int>(st.wYear), static_cast<int>(st.wMonth), static_cast<int>(st.wDay));

  return true;
}

void COSMCtrlAppView::LoadTrackLog()
{
  if (m_bGPXTrackLog)
  {
    //Get the name of the track log
    CString sFileName;
    if (!GetTrackLogFilename(sFileName))
      return;

    try
    {
      m_GPX.Load(sFileName);

      //Preserve any existing tracks if they exist by
      //simply created a new empty track which we will use for our logging
      if (m_GPX.m_Tracks.size() != 0)
      {
        CGPXTrack track;
#pragma warning(suppress: 26486)
        m_GPX.m_Tracks.push_back(track);
      }
    }
    catch(_com_error e)
    {
      CString sMsg;
      sMsg.Format(_T("COSMCtrlAppView::LoadTrackLog, Failed to load GPX file '%s', Error:%08X\n"), sFileName.GetString(), e.Error());
      AfxMessageBox(sMsg, MB_OK | MB_ICONSTOP);
    }
  }
}

bool COSMCtrlAppView::SaveTrackLog(_In_ const CString& sFileName)
{
  //What will be the return value from this function (assume the worst)
  bool bSuccess{false};

  if (m_bGPXTrackLog)
  {
    //Get the name of the track log
    try
    {
      m_GPX.Save(sFileName, g_pszGPXCreator);
      bSuccess = true;
    }
    catch(_com_error e)
    {
      CString sMsg;
      sMsg.Format(_T("COSMCtrlAppView::SaveTrackLog, Failed to save GPX file '%s', Error:%08X\n"), sFileName.GetString(), e.Error());
      AfxMessageBox(sMsg, MB_OK | MB_ICONSTOP);
    }
  }

  return bSuccess;
}

void COSMCtrlAppView::OnViewAllowAnimations() noexcept
{
#ifndef COSMCTRL_NOANIMATION
  m_ctrlOSM.SetDoAnimations(!m_ctrlOSM.GetDoAnimations());
#endif //#ifndef COSMCTRL_NOANIMATION
}

#pragma warning(suppress: 26429)
void COSMCtrlAppView::OnUpdateViewAllowAnimations(CCmdUI* pCmdUI)
{
#ifndef COSMCTRL_NOANIMATION
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ctrlOSM.GetDoAnimations());
#else
#pragma warning(suppress: 26486)
  pCmdUI->Enable(FALSE);
#endif //#ifndef COSMCTRL_NOANIMATION
}

void COSMCtrlAppView::OnFileImportGPXFile()
{
  //Open a file dialog to allow the user to specify a gpx file/s
  CFileDialog dlgFile{TRUE, nullptr, nullptr, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_ALLOWMULTISELECT, _T("GPX Files (*.gpx)|*.gpx|All Files (*.*)|*.*||")};
  CString sFiles;
  constexpr const int nMaxFiles{100};
  constexpr const int nBuffSize{(nMaxFiles * (MAX_PATH + 1)) + 1};
  dlgFile.GetOFN().lpstrFile = sFiles.GetBuffer(nBuffSize);
  dlgFile.GetOFN().nMaxFile = nBuffSize;
  const INT_PTR nResult = dlgFile.DoModal();
  sFiles.ReleaseBuffer();
  if (nResult != IDOK)
    return;

  //Display a wait cursor while we do the import
  CWaitCursor wait;

  //Iterate across each GPX file
  POSITION pos{dlgFile.GetStartPosition()};
  while (pos != nullptr)
  {
    CString sFile;
    try
    {
      //Load up the GPX file from disk
      sFile = dlgFile.GetNextPathName(pos);
      CGPX GPX;
      GPX.Load(sFile);

      //Convert the GPX data to an COSMCtrlPolyline

      //Work through all the tracks in the file
      double fMaxCalculatedSpeed{0};
#pragma warning(suppress: 26489)
      for (std::vector<CGPXTrack>::size_type i{0}; i<GPX.m_Tracks.size(); i++)
      {
        //Pull out the track of interest
#pragma warning(suppress: 26446 26489)
        const CGPXTrack& track{GPX.m_Tracks[i]};

        //Work through all the track segments
#pragma warning(suppress: 26489)
        for (std::vector<CGPXTrackSegment>::size_type j{0}; j<track.m_TrackSegments.size(); j++)
        {
          //Pull out the track segment of interest
#pragma warning(suppress: 26446 26489)
          const CGPXTrackSegment& trackSegment{track.m_TrackSegments[j]};

          //The polyline we will be adding to the map
          auto gpxPolyline{std::make_shared<COSMCtrlPolyline>()};

          //Work thro all the waypoints in the track segment
#pragma warning(suppress: 26489)
          const auto nTrackPoints{trackSegment.m_TrackPoints.size()};
#pragma warning(suppress: 26489)
          gpxPolyline->m_Nodes.reserve(nTrackPoints);
#pragma warning(suppress: 26489)
          for (const auto& waypoint : trackSegment.m_TrackPoints)
          {
            //Update the max calculated speed
#pragma warning(suppress: 26489)
            if (waypoint.m_fCalculatedSpeed > fMaxCalculatedSpeed)
#pragma warning(suppress: 26489)
              fMaxCalculatedSpeed = waypoint.m_fCalculatedSpeed;

            //Add the waypoint to the array of nodes
#pragma warning(suppress: 26489)
            const COSMCtrlNode node{waypoint.m_fLongitude, waypoint.m_fLatitude, 0, waypoint.m_fCalculatedSpeed};
            gpxPolyline->m_Nodes.push_back(node);
          }

          //Set some basic attributes of the polyline
#pragma warning(suppress: 26472)
          gpxPolyline->m_sToolTipText.Format(_T("%s, Track:%d, Track Segment: %d"), sFile.GetString(), static_cast<int>(i+1), static_cast<int>(j+1));
          gpxPolyline->m_bDraggable = false;
          gpxPolyline->m_bEditable = false;

          //Finally add the polyline to the map
#pragma warning(suppress: 26486)
          m_ctrlOSM.m_Polylines.push_back(gpxPolyline);
        }
      }

    #ifndef COSMCTRL_NOD2D
      //Use a color gradient from pure red to pure blue to indicate speed for the GPX track
      for (auto& polyline : m_ctrlOSM.m_Polylines)
      {
#pragma warning(suppress: 26489)
        const auto nNodes{polyline->m_Nodes.size()};
#pragma warning(suppress: 26489)
        polyline->m_colorPenStrokes.reserve(nNodes);
#pragma warning(suppress: 26489)
        for (const auto& node: polyline->m_Nodes)
        {
#pragma warning(suppress: 26489)
          const FLOAT fRed{static_cast<FLOAT>((fMaxCalculatedSpeed - node.m_Position.m_fSpeed) / fMaxCalculatedSpeed)};
#pragma warning(suppress: 26489)
          const FLOAT fBlue{static_cast<FLOAT>(node.m_Position.m_fSpeed / fMaxCalculatedSpeed)};
          polyline->m_colorPenStrokes.push_back(D2D1::ColorF(fRed, 0, fBlue));
        }
      }
    #endif //#ifndef COSMCTRL_NOD2D

      //Work thro all the waypoints in the file
#pragma warning(suppress: 26489)
      const auto nWayPoints{GPX.m_Waypoints.size()};
      for (std::vector<CGPXTrackOrWayPoint>::size_type i{0}; i<nWayPoints; i++)
      {
        //Pull out the waypoint of interest
#pragma warning(suppress: 26446 26489)
        const auto& waypoint{GPX.m_Waypoints[i]};

        //The marker we will be adding to the map
        auto gpxMarker{std::make_shared<COSMCtrlMarker>()};
#pragma warning(suppress: 26489)
        gpxMarker->m_Position = COSMCtrlPosition{waypoint.m_fLongitude, waypoint.m_fLatitude};
#pragma warning(suppress: 26489)
        if (waypoint.m_sName.GetLength())
#pragma warning(suppress: 26489)
          gpxMarker->m_sToolTipText = waypoint.m_sName;
#pragma warning(suppress: 26489)
        else if (waypoint.m_sComment.GetLength())
#pragma warning(suppress: 26489)
          gpxMarker->m_sToolTipText = waypoint.m_sComment;
        else
#pragma warning(suppress: 26472)
          gpxMarker->m_sToolTipText.Format(_T("%s, Waypoint %d"), sFile.GetString(), static_cast<int>(i+1));
        gpxMarker->m_nIconIndex = m_nDefaultMarkerIconIndex;
        gpxMarker->m_bDraggable = false;
        m_ctrlOSM.m_Markers.push_back(gpxMarker);
      }
    }
    catch(_com_error e)
    {
      CString sMsg;
      sMsg.Format(_T("Failed to import file '%s', Error:%08X. Please ensure the file is a valid 1.1 schema GPX file"), sFile.GetString(), e.Error());
      AfxMessageBox(sMsg, MB_OK | MB_ICONSTOP);
    }
  }

  //Force a redraw of the map now that we have completed the import
  m_ctrlOSM.Invalidate();
}

void COSMCtrlAppView::OnFileExportGPXFile()
{
  //Open a file dialog to allow the user to specify a gpx file
  CFileDialog dlgFile{FALSE, _T(".gpx"), nullptr, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("GPX Files (*.gpx)|*.gpx|All Files (*.*)|*.*||")};
  CString sFiles;
  const INT_PTR nResult{dlgFile.DoModal()};
  if (nResult != IDOK)
    return;
  const CString& sFilename{dlgFile.GetPathName()};

  CWaitCursor wait;
  try
  {
    CGPX gpx;

    //Collect Waypoints
    for (const auto& marker : m_ctrlOSM.m_Markers)
    {
      if (marker->m_bSelected)
      {
        CGPXTrackOrWayPoint waypoint;
        waypoint.m_fLatitude = marker->m_Position.m_fLatitude;
        waypoint.m_fLongitude = marker->m_Position.m_fLongitude;
        waypoint.m_sName = marker->m_sToolTipText;
#pragma warning(suppress: 26489)
        gpx.m_Waypoints.push_back(waypoint);
      }
    }

    //Collect Tracks
    CGPXTrack track;
    for (const auto& polyline : m_ctrlOSM.m_Polylines)
    {
      if (polyline->FullySelected())
      {
        CGPXTrackSegment trackSegment;
#pragma warning(suppress: 26472)
        const auto nPoints{static_cast<int>(polyline->m_Nodes.size())};
        for (int j{0}; j<nPoints; j++)
        {
          CGPXTrackOrWayPoint waypoint;
#pragma warning(suppress: 26446)
          const COSMCtrlNode& node{polyline->m_Nodes[j]};
          waypoint.m_fLatitude = node.m_Position.m_fLatitude;
          waypoint.m_fLongitude = node.m_Position.m_fLongitude;
          waypoint.m_sName.Format(_T("Pt. %d"), j);
#pragma warning(suppress: 26489)
          trackSegment.m_TrackPoints.push_back(waypoint);
        }
#pragma warning(suppress: 26489)
        if (trackSegment.m_TrackPoints.size())
#pragma warning(suppress: 26486 26489)
          track.m_TrackSegments.push_back(trackSegment);
      }
      else if (polyline->AnySelected())
      {
        CGPXTrackSegment trackSegment;
#pragma warning(suppress: 26472)
        const auto nPoints{static_cast<int>(polyline->m_Nodes.size())};
        for (int j{0}; j<nPoints; j++)
        {
#pragma warning(suppress: 26446)
          const COSMCtrlNode& node{polyline->m_Nodes[j]};
          if (node.m_bSelected)
          {
            CGPXTrackOrWayPoint waypoint;
            waypoint.m_fLatitude = node.m_Position.m_fLatitude;
            waypoint.m_fLongitude = node.m_Position.m_fLongitude;
            waypoint.m_sName.Format(_T("Pt. %d"), j);
#pragma warning(suppress: 26489)
            trackSegment.m_TrackPoints.push_back(waypoint);
          }
        }
#pragma warning(suppress: 26489)
        if (trackSegment.m_TrackPoints.size())
#pragma warning(suppress: 26486 26489)
          track.m_TrackSegments.push_back(trackSegment);
      }
    }
#pragma warning(suppress: 26489)
    if (track.m_TrackSegments.size())
#pragma warning(suppress: 26486 26489)
      gpx.m_Tracks.push_back(track);
#pragma warning(suppress: 26489)
    if (gpx.m_Tracks.size() || gpx.m_Waypoints.size())
#pragma warning(suppress: 26486)
      gpx.Save(sFilename, g_pszGPXCreator);
    else
      AfxMessageBox(_T("Please select some markers or polylines on the map to save!"), MB_OK | MB_ICONSTOP);
  }
  catch (_com_error e)
  {
    CString sMsg;
    sMsg.Format(_T("Failed to export file '%s', Error:%08X"), sFilename.GetString(), e.Error());
    AfxMessageBox(sMsg, MB_OK | MB_ICONSTOP);
  }
}

void COSMCtrlAppView::DoAddressLookup(_In_ const CPoint& point)
{
  //Get the client rect
  CRect rClient;
  m_ctrlOSM.GetClientRect(&rClient);

  //Get the position
#ifdef COSMCTRL_NOD2D
  const Gdiplus::PointF tempPoint{static_cast<Gdiplus::REAL>(point.x), static_cast<Gdiplus::REAL>(point.y)};
#else
  const CD2DPointF tempPoint{static_cast<FLOAT>(point.x), static_cast<FLOAT>(point.y)};
#endif //#ifdef COSMCTRL_NOD2D
  COSMCtrlPosition position;
  if (m_ctrlOSM.ClientToPosition(tempPoint, rClient, position))
  {
    //Do the Nominatim lookup
    Nominatim::CReverseGeocodingQuery query;
    query.m_fLatitude = position.m_fLatitude;
    query.m_fLongitude = position.m_fLongitude;
#pragma warning(suppress: 26489)
    query.m_sUserAgent = AfxGetAppName();
    Nominatim::CReverseGeocodingQueryResult result;
    Nominatim::CNominatim nominatim;
    CWaitCursor wait;
#pragma warning(suppress: 26486)
    const HRESULT hr{nominatim.ReverseGeocoding(query, result)};
    if (SUCCEEDED(hr))
    {
      auto nominatimMarker{std::make_shared<COSMCtrlMarker>()};
      nominatimMarker->m_Position = std::move(COSMCtrlPosition{position.m_fLongitude, position.m_fLatitude});
      nominatimMarker->m_sToolTipText = result.m_sDisplayName.c_str();
      nominatimMarker->m_nIconIndex = m_nDefaultMarkerIconIndex;
      nominatimMarker->m_bDraggable = false;
      m_ctrlOSM.m_Markers.push_back(nominatimMarker);
      m_ctrlOSM.Invalidate();
    }
    else
    {
      //Report the error
      CString sError;
      sError.Format(_T("%08X"), hr);
      CString sMessage;
      AfxFormatString1(sMessage, IDS_FAIL_NOMINATIM_ADDRESS_LOOKUP, sError);
      AfxMessageBox(sMessage, MB_OK | MB_ICONSTOP);
    }
  }
}

void COSMCtrlAppView::OnViewSearch()
{
  //Show the search dialog
  CSearchDlg dlg;
  if ((dlg.DoModal() == IDOK) && dlg.m_sSearch.GetLength())
  {
    Nominatim::CSearchQuery query;
#pragma warning(suppress: 26489)
    query.m_sUserAgent = AfxGetAppName();
#pragma warning(suppress: 26489)
    query.m_sQueryString = dlg.m_sSearch;
    Nominatim::CNominatim nominatim;
    Nominatim::CSearchPlaceArray result;
    CWaitCursor wait;
#pragma warning(suppress: 26486)
    const HRESULT hr{nominatim.Search(query, result)};
    if (SUCCEEDED(hr))
    {
      const auto nItemsFound{result.size()};
      if (nItemsFound == 0)
        AfxMessageBox(IDS_NOMINATIM_SEARCH_NO_RESULTS, MB_OK | MB_ICONSTOP);
      else if (nItemsFound == 1)
      {
#pragma warning(suppress: 26446)
        const Nominatim::CSearchPlace& place{result[0]};

        auto nominatimMarker{std::make_shared<COSMCtrlMarker>()};
        nominatimMarker->m_Position = std::move(COSMCtrlPosition{place.m_fLongitude, place.m_fLatitude});
#pragma warning(suppress: 26486 26489)
        nominatimMarker->m_sToolTipText = place.m_sDisplayName.c_str();
        nominatimMarker->m_nIconIndex = m_nDefaultMarkerIconIndex;
        nominatimMarker->m_bDraggable = false;
        m_ctrlOSM.m_Markers.push_back(nominatimMarker);
#pragma warning(suppress: 26486)
        m_ctrlOSM.SetCenter(nominatimMarker->m_Position, 0);
        m_ctrlOSM.Invalidate();
      }
      else if (nItemsFound > 1)
      {
        //Display the search results dialog to allow the user to select which POI to go to
        CSearchResultsDlg searchResultsDlg;
        searchResultsDlg.m_pResults = &result;
        if ((searchResultsDlg.DoModal() == IDOK) && (searchResultsDlg.m_nResult != LB_ERR))
        {
#pragma warning(suppress: 26446)
          const Nominatim::CSearchPlace& place{result[searchResultsDlg.m_nResult]};

          auto nominatimMarker{std::make_shared<COSMCtrlMarker>()};
          nominatimMarker->m_Position = std::move(COSMCtrlPosition{place.m_fLongitude, place.m_fLatitude});
#pragma warning(suppress: 26486 26489)
          nominatimMarker->m_sToolTipText = place.m_sDisplayName.c_str();
          nominatimMarker->m_nIconIndex = m_nDefaultMarkerIconIndex;
          nominatimMarker->m_bDraggable = false;
          m_ctrlOSM.m_Markers.push_back(nominatimMarker);
#pragma warning(suppress: 26486)
          m_ctrlOSM.SetCenter(nominatimMarker->m_Position, 0);
          m_ctrlOSM.Invalidate();
        }
      }
    }
    else
    {
      //Report the error
      CString sError;
      sError.Format(_T("%08X"), hr);
      CString sMessage;
      AfxFormatString1(sMessage, IDS_FAIL_NOMINATIM_SEARCH, sError);
      AfxMessageBox(sMessage, MB_OK | MB_ICONSTOP);
    }
  }
}

bool COSMCtrlAppView::OnOSMCtrlLButtonDown(_In_ UINT /*nFlags*/, _In_ const CPoint& point)
{
  switch (m_MapPointerMode)
  {
    case MapPointerMode::RefreshTile:
    {
      DoRefreshTile(point);
      break;
    }
    case MapPointerMode::ViewTileProperties:
    {
      DoTileProperties(point);
      break;
    }
    case MapPointerMode::AddressLookup:
    {
      DoAddressLookup(point);
      break;
    }
    default:
    {
      break;
    }
  }

  const MapPointerMode tempMapPointerMode{m_MapPointerMode};
  m_MapPointerMode = MapPointerMode::Undefined;
  return (tempMapPointerMode != MapPointerMode::Undefined);
}

void COSMCtrlAppView::OnViewAddressLookup()
{
  //Ask the user to click on the part of the map where they want to lookup the address
  AfxMessageBox(IDS_CLICK_ON_MAP_FOR_ADDRESSLOOKUP, MB_OK);

  m_MapPointerMode = MapPointerMode::AddressLookup;
}

void COSMCtrlAppView::DoRefreshTile(_In_ const CPoint& point)
{
  //Get the client rect
  CRect rClient;
  m_ctrlOSM.GetClientRect(&rClient);

  //Get the position
#ifdef COSMCTRL_NOD2D
  const Gdiplus::PointF tempPoint{static_cast<Gdiplus::REAL>(point.x), static_cast<Gdiplus::REAL>(point.y)};
#else
  const CD2DPointF tempPoint{static_cast<FLOAT>(point.x), static_cast<FLOAT>(point.y)};
#endif //#ifdef COSMCTRL_NOD2D
  COSMCtrlPosition position;
  if (m_ctrlOSM.ClientToPosition(tempPoint, rClient, position))
  {
    const double fZoom{m_ctrlOSM.GetZoom()};
    const int nZoom{static_cast<int>(fZoom)};
    const double fX{COSMCtrlHelper::Longitude2TileX(position.m_fLongitude, nZoom)};
    const int nTileX = static_cast<int>(fX);
    const double fY{COSMCtrlHelper::Latitude2TileY(position.m_fLatitude, nZoom)};
    const int nTileY{static_cast<int>(fY)};

    //Delete the cached tile
    DeleteFile(m_ctrlOSM.GetTileCachePath(m_ctrlOSM.GetCacheDirectory(), nZoom, nTileX, nTileY));

    //Force a refresh of the control
    m_ctrlOSM.Invalidate();
    m_ctrlOSM.UpdateWindow();
    m_ctrlOSM.Refresh();
  }
}

void COSMCtrlAppView::DoTileProperties(_In_ const CPoint& point)
{
  //Get the client rect
  CRect rClient;
  m_ctrlOSM.GetClientRect(&rClient);

  //Get the position
#ifdef COSMCTRL_NOD2D
  const Gdiplus::PointF tempPoint{static_cast<Gdiplus::REAL>(point.x), static_cast<Gdiplus::REAL>(point.y)};
#else
  const CD2DPointF tempPoint{static_cast<FLOAT>(point.x), static_cast<FLOAT>(point.y)};
#endif //#ifdef COSMCTRL_NOD2D

  //Display the dialog with all the tile properties set
  CTilePropertiesDlg dlg;
  //Fill in the tile provider value
#pragma warning(suppress: 26429)
  IOSMCtrlTileProvider* pTileProvider{m_ctrlOSM.GetTileProvider()};
  OSMCtrlAppTileProvider tileProvider{OSMCtrlAppTileProvider::Mapnik};
  if (pTileProvider == &m_CyclemapTileProvider)
    tileProvider = OSMCtrlAppTileProvider::Cyclemap;
  switch (tileProvider)
  {
    case OSMCtrlAppTileProvider::Mapnik:
    {
      dlg.m_sProvider = _T("Mapnik");
      break;
    }
    case OSMCtrlAppTileProvider::Cyclemap:
    {
      dlg.m_sProvider = _T("Cyclemap");
      break;
    }
    default:
    {
      ASSERT(false);
      break;
    }
  }

  //Get the tile coordinates
  COSMCtrlPosition cursorPosition;
  if (m_ctrlOSM.ClientToPosition(tempPoint, rClient, cursorPosition))
  {
    const double fZoom{m_ctrlOSM.GetZoom()};
    const int nZoom{static_cast<int>(fZoom)};
    const double fX{COSMCtrlHelper::Longitude2TileX(cursorPosition.m_fLongitude, nZoom)};
    const int nTileX{static_cast<int>(fX)};
    const double fY{COSMCtrlHelper::Latitude2TileY(cursorPosition.m_fLatitude, nZoom)};
    const int nTileY{static_cast<int>(fY)};
    dlg.m_sTileCoordinates.Format(_T("X: %d, Y: %d"), nTileX, nTileY);

    //Get the center point of the tile
    const double fLatitude{COSMCtrlHelper::TileY2Latitude(nTileY + 0.5, nZoom)};
    const double fAbsLatitude{fabs(fLatitude)};
    const int nLatitudeD{static_cast<int>(fAbsLatitude)};
    const int nLatitudeM{static_cast<int>((fAbsLatitude - nLatitudeD) * 60)};
    const int nLatitudeS{static_cast<int>((fAbsLatitude - nLatitudeD - nLatitudeM/60.0) * 3600)};
    const double fLongitude{COSMCtrlHelper::TileX2Longitude(nTileX + 0.5, nZoom)};
    const double fAbsLongitude{fabs(fLongitude)};
    const int nLongitudeD{static_cast<int>(fAbsLongitude)};
    const int nLongitudeM{static_cast<int>((fAbsLongitude - nLongitudeD) * 60)};
    const int nLongitudeS{static_cast<int>((fAbsLongitude - nLongitudeD - nLongitudeM/60.0) * 3600)};
#pragma warning(suppress: 26485)
    dlg.m_sCenterPosition.Format(_T("%d %d' %d\" %s  %d %d' %d\" %s"), nLatitudeD, nLatitudeM, nLatitudeS, (fLatitude > 0) ? _T("N") : _T("S"), nLongitudeD, nLongitudeM, nLongitudeS, (fLongitude > 0) ? _T("E") : _T("W"));

    //Get the tile URL
    dlg.m_sURL = pTileProvider->GetDownloadURL(nZoom, nTileX, nTileY);

    //Get the cache path
    dlg.m_sCachePath = m_ctrlOSM.GetTileCachePath(m_ctrlOSM.GetCacheDirectory(), nZoom, nTileX, nTileY);

    //Get the rerender and status URLs
    if (tileProvider == OSMCtrlAppTileProvider::Mapnik)
    {
      dlg.m_sRerenderURL = dlg.m_sURL + _T("/dirty");
      dlg.m_sStatusURL = dlg.m_sURL + _T("/status");
    }

    //Get the dimensions

    //First do the vertical distance
    double fLatitude1{COSMCtrlHelper::TileY2Latitude(nTileY, nZoom)};
    double fLongitude1{COSMCtrlHelper::TileX2Longitude(nTileX, nZoom)};
    const double fLatitude2{COSMCtrlHelper::TileY2Latitude(static_cast<double>(nTileY) + 1, nZoom)};
    double fVerticalDistance{COSMCtrlHelper::DistanceBetweenPoints(COSMCtrlPosition(fLongitude1, fLatitude1), COSMCtrlPosition(fLongitude1, fLatitude2), nullptr, nullptr) / 1000};

    //Then the horizontal distance
    fLatitude1 = COSMCtrlHelper::TileY2Latitude(static_cast<double>(nTileY) + 1, nZoom);
    fLongitude1 = COSMCtrlHelper::TileX2Longitude(nTileX, nZoom);
    const double fLongitude2{COSMCtrlHelper::TileX2Longitude(nTileX + (fZoom == 0 ? 0.5 : 1), nZoom)};
    double fHorizontalDistance{COSMCtrlHelper::DistanceBetweenPoints(COSMCtrlPosition(fLongitude1, fLatitude1), COSMCtrlPosition(fLongitude2, fLatitude1), nullptr, nullptr) / 1000};
    if (fZoom == 0)
      fHorizontalDistance *= 2;

    //Lets use the Imperial or Metric system of measurement based upon the current user's preferences
    bool bMetric{true};
    CString sMeasure;
    const int nGLI{GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_IMEASURE, sMeasure.GetBuffer(3), 3)};
    sMeasure.ReleaseBuffer();
    if (nGLI)
    {
      if (sMeasure == _T("1"))
      {
        //Convert the measured distance to miles
        bMetric = false;
        fVerticalDistance *= 0.621371192;
        fHorizontalDistance *= 0.621371192;
      }
    }

    CString sVerticalDistance;
    if (bMetric)
    {
      if (fVerticalDistance < 1)
        sVerticalDistance.Format(_T("%.0f Meters"), fVerticalDistance * 1000);
      else
        sVerticalDistance.Format(_T("%.3f Kilometers"), fVerticalDistance);
    }
    else
      sVerticalDistance.Format(_T("%.3f Miles"), fVerticalDistance);

    CString sHorizontalDistance;
    if (bMetric)
    {
      if (fHorizontalDistance < 1)
        sHorizontalDistance.Format(_T("%.0f Meters"), fHorizontalDistance * 1000);
      else
        sHorizontalDistance.Format(_T("%.3f Kilometers"), fHorizontalDistance);
    }
    else
      sHorizontalDistance.Format(_T("%.3f Miles"), fHorizontalDistance);
    dlg.m_sDimensions.Format(_T("%s vertical by %s horizontal"), sVerticalDistance.GetString(), sHorizontalDistance.GetString());

    //Finally show the dialog
    if (dlg.DoModal() == -1)
    {
      //Display an error message if we could not show the dialog
      AfxMessageBox(_T("Unable to show the Tile Properties dialog window. Please ensure that you are running a Unicode build of the app as the dialog uses SysLink controls which are only supported for Unicode"), MB_OK | MB_ICONSTOP);
    }
  }
}

void COSMCtrlAppView::OnViewRefreshTile()
{
  //Ask the user to click on the part of the map where they want to refresh the tile
  AfxMessageBox(IDS_CLICK_ON_MAP_FOR_REFRESHTILE, MB_OK);

  m_MapPointerMode = MapPointerMode::RefreshTile;
}

void COSMCtrlAppView::OnViewTileProperties()
{
  //Ask the user to click on the part of the map where they want tile properties
  AfxMessageBox(IDS_CLICK_ON_MAP_FOR_TILEPROPERTIES, MB_OK);

  m_MapPointerMode = MapPointerMode::ViewTileProperties;
}

void COSMCtrlAppView::OnViewGotoCoordinates()
{
  //Display the goto coordinates dialog
  CGotoCoordinatesDlg dlg;
  if (dlg.DoModal() == IDOK)
  {
    COSMCtrlPosition position;
    if (dlg.m_fLongitudeDegrees >= 0)
      position.m_fLongitude = dlg.m_fLongitudeDegrees + (dlg.m_fLongitudeMinutes/60) + (dlg.m_fLongitudeSeconds/3600);
    else
      position.m_fLongitude = dlg.m_fLongitudeDegrees - (dlg.m_fLongitudeMinutes/60) - (dlg.m_fLongitudeSeconds/3600);
    if (dlg.m_fLatitudeDegrees >= 0)
      position.m_fLatitude = dlg.m_fLatitudeDegrees + (dlg.m_fLatitudeMinutes/60) + (dlg.m_fLatitudeSeconds/3600);
    else
      position.m_fLatitude = dlg.m_fLatitudeDegrees - (dlg.m_fLatitudeMinutes/60) - (dlg.m_fLatitudeSeconds/3600);
    m_ctrlOSM.SetCenter(position, 0);
  }
}

STDMETHODIMP COSMCtrlAppView::OnLeave(__RPC__in_opt REFSENSOR_ID sensorID)
{
  //Is it the sensor we are using which has left
  if (sensorID == m_SensorID)
  {
    if (m_bGPXTrackLog)
    {
      //Do the final save of the track log if necessary
      CString sTrackLogFilename;
      if (GetTrackLogFilename(sTrackLogFilename))
        SaveTrackLog(sTrackLogFilename);
    }

    //Close down our sensor
    m_Sensor.Release();

    //Mark the GPS position as invalid
    m_ctrlOSM.AddGPSTrack(false, 0, 0, 0, 0, false, false, 0);
  }

  return S_OK;
}

STDMETHODIMP COSMCtrlAppView::OnDataUpdated(__RPC__in_opt ISensor* /*pSensor*/, __RPC__in_opt ISensorDataReport* pNewData)
{
  //Attach our helper class which makes working with location data reports easier
  SensorAPI::CLocationSensorDataReport gpsDataReport{pNewData};

  //Get the data report timestamp
  SYSTEMTIME st;
  if (FAILED(gpsDataReport->GetTimestamp(&st)))
    return S_OK;

  //Get the Latitude
  double fLatitude{0};
  const HRESULT hr1{gpsDataReport.GetLatitude(fLatitude)};

  //Get the Longitude
  double fLongitude{0};
  const HRESULT hr2{gpsDataReport.GetLongitude(fLongitude)};

  //Get the fix quality
  int nFixQuality{0};
  const HRESULT hr3{gpsDataReport.GetFixQuality(nFixQuality)};

  //Get the true heading
  double fTrueHeading{0};
  const HRESULT hr4{gpsDataReport.GetTrueHeading(fTrueHeading)};

  //Get the speed
  double fSpeed{0};
  const HRESULT hr5{gpsDataReport.GetSpeed(fSpeed)};

  //Get the HDOP
  double dHDOP{0};
  gpsDataReport.GetHDOP(dHDOP);

  //Add the position to the track if it is valid
  const bool bHadPreviousTrack{m_ctrlOSM.m_GPSTrack->m_Nodes.size() != 0};
#pragma warning(suppress: 6102)
  m_ctrlOSM.AddGPSTrack(SUCCEEDED(hr3) && (nFixQuality != 0), fLongitude, fLatitude, fTrueHeading, fSpeed, SUCCEEDED(hr4), SUCCEEDED(hr5), dHDOP);

  //recenter the map if necessary
  if (SUCCEEDED(hr1) && SUCCEEDED(hr2))
  {
    if (m_bGPSCenter)
    {
      const bool bChangeCenter{(GetTickCount64() - m_ctrlOSM.GetLastCenterTickCount()) >= DELAY_BEFORE_RECENTER}; //Allow a reasonable delay before we recenter the map
      const double fCurrentZoom{m_ctrlOSM.GetZoom()};
      if (m_bChangeBearingOfMap)
      {
        if (bChangeCenter)
          m_ctrlOSM.SetCenterAndZoomAndBearing(COSMCtrlPosition{fLongitude, fLatitude}, fCurrentZoom >= 18 ? fCurrentZoom : 18, fTrueHeading, !bHadPreviousTrack);
      }
      else
      {
        if (bChangeCenter)
          m_ctrlOSM.SetCenterAndZoom(COSMCtrlPosition{fLongitude, fLatitude}, fCurrentZoom >= 18 ? fCurrentZoom : 18, !bHadPreviousTrack);
      }
    }
    else
    {
    #ifndef COSMCTRL_NOD2D
      if (m_bChangeBearingOfMap && (GetTickCount64() - m_ctrlOSM.GetLastCenterTickCount()) >= DELAY_BEFORE_RESET_BEARING) //Allow a reasonable delay before we reset the bearing of the map
        m_ctrlOSM.SetBearingOfTopOfMap(fTrueHeading, !bHadPreviousTrack);
    #endif //#ifndef COSMCTRL_NOD2D
    }
  }

  if (m_bGPXTrackLog)
  {
    //Get a pointer to the active track
    CGPXTrack* pActiveTrack{nullptr};
    const auto nTracks{m_GPX.m_Tracks.size()};
    if (nTracks == 0)
    {
      CGPXTrack track;
#pragma warning(suppress: 26486)
      m_GPX.m_Tracks.push_back(track);
      const auto nIndex{m_GPX.m_Tracks.size() - 1};
#pragma warning(suppress: 26446)
      pActiveTrack = &(m_GPX.m_Tracks[nIndex]);
    }
    else
#pragma warning(suppress: 26446)
      pActiveTrack = &(m_GPX.m_Tracks[nTracks - 1]);

    //Create a new track segment if the fix status goes from false to true
    CGPXTrackSegment* pActiveTrackSegment{nullptr};
    if (!m_bGPSFix)
    {
      if (SUCCEEDED(hr3) && (nFixQuality != 0))
      {
        CGPXTrackSegment trackSegment;
#pragma warning(suppress: 26486 26489)
        pActiveTrack->m_TrackSegments.push_back(trackSegment);
        const auto nIndex{pActiveTrack->m_TrackSegments.size() - 1};
#pragma warning(suppress: 26446)
        pActiveTrackSegment = &(pActiveTrack->m_TrackSegments[nIndex]);

        //Remember the fix value for the next time around
        m_bGPSFix = true;
      }
    }
    else
    {
      //Just pull out the current active segment
#pragma warning(suppress: 26446 26489)
      pActiveTrackSegment = &(pActiveTrack->m_TrackSegments[pActiveTrack->m_TrackSegments.size() - 1]);
    }

    //Add a new point to the active segment if we can
    if (pActiveTrackSegment && m_bGPSFix)
    {
      CGPXTrackOrWayPoint waypoint;
      waypoint.m_fLatitude = fLatitude;
      waypoint.m_fLongitude = fLongitude;
      memcpy_s(&waypoint.m_Time, sizeof(waypoint.m_Time), &st, sizeof(st));
#pragma warning(suppress: 26489)
      pActiveTrackSegment->m_TrackPoints.push_back(waypoint);

      //Get the name of the file we should be currently saving to
      CString sTrackLogFilename;
      if (!GetTrackLogFilename(sTrackLogFilename))
        return S_OK;

      //For efficiency reasons we only save the file every 60th new waypoint in the track segment or
      //when the filename changes due to a midnight tick over. For most GPS devices every 60th new waypoint
      //will correspond to once every minute
#pragma warning(suppress: 26489)
      if (((pActiveTrackSegment->m_TrackPoints.size() % 60) == 0) || (sTrackLogFilename != m_sLastTrackLogFilename))
        SaveTrackLog(sTrackLogFilename);

      //Remember the name of the track log filename for the next time around
      m_sLastTrackLogFilename = sTrackLogFilename;
    }
  }

  return S_OK;
}

void COSMCtrlAppView::OnRMC(const GPSCom2::String& /*sSentence*/, const GPSCom2::CRMCSentence& sentence)
{
  //Add the position to the track if it is valid
  const bool bHadPreviousTrack{m_ctrlOSM.m_GPSTrack->m_Nodes.size() != 0};
  m_ctrlOSM.AddGPSTrack(sentence.m_Status == GPSCom2::BOOLEAN::NMEA_TRUE, sentence.m_Longitude.dValue, sentence.m_Latitude.dValue, sentence.m_dBearing, sentence.m_dSpeedOverGround, sentence.m_bBearingValid, sentence.m_bSpeedOverGroundValid, m_GGA.m_bHDOPValid ? m_GGA.m_dHDOP : 0);

  //recenter / reorient the map if necessary
  if (sentence.m_Latitude.bValid && sentence.m_Longitude.bValid)
  {
    if (m_bGPSCenter)
    {
      const bool bChangeCenter{(GetTickCount64() - m_ctrlOSM.GetLastCenterTickCount()) >= DELAY_BEFORE_RECENTER}; //Allow a reasonable delay before we recenter the map
      const double fCurrentZoom{m_ctrlOSM.GetZoom()};
      if (m_bChangeBearingOfMap)
      {
        if (bChangeCenter)
          m_ctrlOSM.SetCenterAndZoomAndBearing(COSMCtrlPosition{sentence.m_Longitude.dValue, sentence.m_Latitude.dValue}, fCurrentZoom >= 18 ? fCurrentZoom : 18, sentence.m_dBearing, !bHadPreviousTrack);
      }
      else
      {
        if (bChangeCenter)
          m_ctrlOSM.SetCenterAndZoom(COSMCtrlPosition{sentence.m_Longitude.dValue, sentence.m_Latitude.dValue}, fCurrentZoom >= 18 ? fCurrentZoom : 18, !bHadPreviousTrack);
      }
    }
    else
    {
    #ifndef COSMCTRL_NOD2D
      if (m_bChangeBearingOfMap && (GetTickCount64() - m_ctrlOSM.GetLastCenterTickCount()) >= DELAY_BEFORE_RESET_BEARING) //Allow a reasonable delay before we reset the bearing of the map
        m_ctrlOSM.SetBearingOfTopOfMap(sentence.m_dBearing, !bHadPreviousTrack);
    #endif //#ifndef COSMCTRL_NOD2D
    }
  }

  if (m_bGPXTrackLog)
  {
    //Get a pointer to the active track
    CGPXTrack* pActiveTrack{nullptr};
    const auto nTracks{m_GPX.m_Tracks.size()};
    if (nTracks == 0)
    {
      CGPXTrack track;
#pragma warning(suppress: 26486)
      m_GPX.m_Tracks.push_back(track);
      const auto nIndex{m_GPX.m_Tracks.size() - 1};
#pragma warning(suppress: 26446)
      pActiveTrack = &(m_GPX.m_Tracks[nIndex]);
    }
    else
#pragma warning(suppress: 26446)
      pActiveTrack = &(m_GPX.m_Tracks[nTracks - 1]);

    //Create a new track segment if the fix status goes from false to true
    CGPXTrackSegment* pActiveTrackSegment{nullptr};
    if (!m_bGPSFix)
    {
      if (sentence.m_Status == GPSCom2::BOOLEAN::NMEA_TRUE)
      {
        CGPXTrackSegment trackSegment;
#pragma warning(suppress: 26486 26489)
        pActiveTrack->m_TrackSegments.push_back(trackSegment);
        const auto nIndex{pActiveTrack->m_TrackSegments.size() - 1};
#pragma warning(suppress: 26446)
        pActiveTrackSegment = &(pActiveTrack->m_TrackSegments[nIndex]);

        //Remember the fix value for the next time around
        m_bGPSFix = true;
      }
    }
    else
    {
      //Just pull out the current active segment
#pragma warning(suppress: 26446 26489)
      pActiveTrackSegment = &(pActiveTrack->m_TrackSegments[pActiveTrack->m_TrackSegments.size() - 1]);
    }

    //Add a new point to the active segment if we can
    if (pActiveTrackSegment && m_bGPSFix)
    {
      CGPXTrackOrWayPoint waypoint;
      waypoint.m_fLatitude = sentence.m_Latitude.dValue;
      waypoint.m_fLongitude = sentence.m_Longitude.dValue;
#pragma warning(suppress: 26472)
      waypoint.m_Time.wYear = static_cast<WORD>(sentence.m_Date.nYear);
#pragma warning(suppress: 26472)
      waypoint.m_Time.wMonth = static_cast<WORD>(sentence.m_Date.nMonth);
#pragma warning(suppress: 26472)
      waypoint.m_Time.wDay = static_cast<WORD>(sentence.m_Date.nDay);
#pragma warning(suppress: 26472)
      waypoint.m_Time.wHour = static_cast<WORD>(sentence.m_Time.nHour);
#pragma warning(suppress: 26472)
      waypoint.m_Time.wMinute = static_cast<WORD>(sentence.m_Time.nMinute);
#pragma warning(suppress: 26472)
      waypoint.m_Time.wSecond = static_cast<WORD>(sentence.m_Time.nSecond);
#pragma warning(suppress: 26489)
      pActiveTrackSegment->m_TrackPoints.push_back(waypoint);

      //Get the name of the file we should be currently saving to
      CString sTrackLogFilename;
      if (!GetTrackLogFilename(sTrackLogFilename))
        return;

      //For efficiency reasons we only save the file every 60th new waypoint in the track segment or
      //when the filename changes due to a midnight tick over. For most GPS devices every 60th new waypoint
      //will correspond to once every minute
#pragma warning(suppress: 26489)
      if (((pActiveTrackSegment->m_TrackPoints.size() % 60) == 0) || (sTrackLogFilename != m_sLastTrackLogFilename))
        SaveTrackLog(sTrackLogFilename);

      //Remember the name of the track log filename for the next time around
      m_sLastTrackLogFilename = sTrackLogFilename;
    }
  }
}

void COSMCtrlAppView::OnViewSettings()
{
  CSettingsDlg dlg;

  //Setup the dialog values
#pragma warning(suppress: 26472)
  const int nOldType{static_cast<int>(theApp.GetProfileInt(_T("General"), _T("ProxyServerType"), dlg.m_Type))};
  dlg.m_Type = nOldType;
  CString sOldProxyServer{m_ctrlOSM.GetProxyServer()};
  CString sOldProxyBypassList{m_ctrlOSM.GetProxyBypassList()};
  dlg.m_sProxyServer = sOldProxyServer;
  dlg.m_sProxyServerBypassList = sOldProxyBypassList;

  //Show the dialog
  if (dlg.DoModal() == IDOK)
  {
    CString sProxyServer;
    CString sProxyBypassList;
    switch (static_cast<CSettingsDlg::ProxyServerType>(dlg.m_Type))
    {
      case CSettingsDlg::ProxyServerType::UseSettingsFromIE:
      {
        WINHTTP_CURRENT_USER_IE_PROXY_CONFIG proxyConfig{};
        if (!WinHttpGetIEProxyConfigForCurrentUser(&proxyConfig))
          return;
        sProxyServer = proxyConfig.lpszProxy;
        sProxyBypassList = proxyConfig.lpszProxyBypass;

        //Free up the allocated memory
        if (proxyConfig.lpszAutoConfigUrl != nullptr)
          GlobalFree(proxyConfig.lpszAutoConfigUrl);
        if (proxyConfig.lpszProxy != nullptr)
          GlobalFree(proxyConfig.lpszProxy);
        if (proxyConfig.lpszProxyBypass != nullptr)
          GlobalFree(proxyConfig.lpszProxyBypass);
        break;
      }
      case CSettingsDlg::ProxyServerType::DirectConnection:
      {
        //Nothing to do for this case
        break;
      }
      case CSettingsDlg::ProxyServerType::SpecificProxyServer:
      {
        sProxyServer = dlg.m_sProxyServer;
        sProxyBypassList = dlg.m_sProxyServerBypassList;
        break;
      }
      default:
      {
        ASSERT(false);
        break;
      }
    }

    theApp.WriteProfileString(_T("General"), _T("ProxyServer"), sProxyServer);
    theApp.WriteProfileString(_T("General"), _T("ProxyBypassList"), sProxyBypassList);
    theApp.WriteProfileInt(_T("General"), _T("ProxyServerType"), dlg.m_Type);

    if ((dlg.m_Type != nOldType) || (sProxyServer != sOldProxyServer) || (sProxyBypassList != sOldProxyBypassList))
      AfxMessageBox(_T("Please note that you will need to restart the application for this new setting to take effect"), MB_OK | MB_ICONEXCLAMATION);
    else
    {
      m_ctrlOSM.SetProxyServer(sProxyServer);
      m_ctrlOSM.SetProxyBypassList(sProxyBypassList);
    }
  }
}
