/*
Module : OSMCtrlCachedTile.h
Purpose: Defines the interface for COSMCtrlCachedTile class
Created: PJN / 10-04-2011

Copyright (c) 2011 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Includes ////////////////////////////////////////

#pragma once

#ifndef __OSMCTRLCACHEDTILE_H__
#define __OSMCTRLCACHEDTILE_H__

#ifndef _MEMORY_
#pragma message("To avoid this message, please put memory in your pre compiled header (normally stdafx.h)")
#include <memory>
#endif //#ifndef _MEMORY_


//////////////////// Classes //////////////////////////////////////////////////

//A class used internally by the ctrl class for caching tiles
class COSMCtrlCachedTile
{
public:
//Member variables
  int m_nTileX{-1};
  int m_nTileY{-1};
  int m_nZoom{-1};
  int m_nInsertionCounter{-1};
#ifdef COSMCTRL_NOD2D
  std::shared_ptr<Gdiplus::CachedBitmap> m_pCachedBitmap;
  std::shared_ptr<Gdiplus::Bitmap> m_pBitmap;
#else
  CD2DBitmap* m_pCachedBitmap{nullptr};
#endif //#ifdef COSMCTRL_NOD2D
  bool m_bMostRecent{true};
};


#endif //#ifndef __OSMCTRLCACHEDTILE_H__
