/*
Module : OSMCtrlHandler.h
Purpose: Defines the interface for IOSMCtrlHandler class
Created: PJN / 10-04-2011

Copyright (c) 2011 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Includes ////////////////////////////////////////

#pragma once

#ifndef __OSMCTRLHANDLER_H__
#define __OSMCTRLHANDLER_H__


//////////////////// Classes //////////////////////////////////////////////////

//The event handler class
class IOSMCtrlHandler
{
public:
//Constructors / Destructors
  IOSMCtrlHandler() = default;
  IOSMCtrlHandler(const IOSMCtrlHandler&) = delete;
  IOSMCtrlHandler(IOSMCtrlHandler&&) = delete;
  virtual ~IOSMCtrlHandler() = default;

//Methods
  IOSMCtrlHandler& operator=(const IOSMCtrlHandler&) = delete;
  IOSMCtrlHandler& operator=(IOSMCtrlHandler&&) = delete;
#pragma warning(suppress: 26440)
  virtual bool OnOSMCtrlLButtonDown(_In_ UINT /*nFlags*/, _In_ const CPoint& /*point*/)
  {
    return false;
  }
#pragma warning(suppress: 26440)
  virtual bool OnOSMCtrlMouseMove(_In_ UINT/*nFlags*/, _In_ const CPoint& /*point*/)
  {
    return false;
  }
#pragma warning(suppress: 26440)
  virtual bool OnOSMCtrlLButtonUp(_In_ UINT /*nFlags*/, _In_ const CPoint& /*point*/)
  {
    return false;
  }
#pragma warning(suppress: 26440)
  virtual bool OnOSMCtrlKeyDown(_In_ UINT /*nChar*/, _In_ UINT /*nRepCnt*/, _In_ UINT /*nFlags*/)
  {
    return false;
  }
#pragma warning(suppress: 26440)
  virtual bool OnOSMCtrlLButtonDblClk(_In_ UINT /*nFlags*/, _In_ const CPoint& /*point*/)
  {
    return false;
  }
};


#endif //#ifndef __OSMCTRLHANDLER_H__
