/*
Module : OSMCtrlIcon.h
Purpose: Defines the interface for COSMCtrlIcon class
Created: PJN / 10-04-2011

Copyright (c) 2011 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Includes ////////////////////////////////////////

#pragma once

#ifndef __OSMCTRLICON_H__
#define __OSMCTRLICON_H__


//////////////////// Classes //////////////////////////////////////////////////

//A class which represents an icon as placed on the main COSMCtrl class instance
class COSMCtrlIcon
{
public:
//Member variables
#ifdef COSMCTRL_NOD2D
  std::shared_ptr<Gdiplus::Image> m_Image; //The actual image
#else
  UINT m_nResourceID{0}; //The resource identifier to load the icon from
  CString m_sResourceType; //The resource type of the icon
  CString m_sFilename; //The filename to load the icon from
  CD2DBitmap* m_pImage{nullptr}; //The cached image
#endif //#ifdef COSMCTRL_NOD2D
  CPoint m_ptAnchor{0, 0}; //The anchor position of the icon i.e. the offset in pixels from the top left of the icon which is anchored to the map
};


#endif //#ifndef __OSMCTRLICON_H__
