/*
Module : OSMCtrlPosition.cpp
Purpose: Implementation for the COSMCtrlPosition class
Created: PJN / 10-04-2011
History: PJN / None

Copyright (c) 2011 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Includes /////////////////////////////////////////////////

#include "stdafx.h"
#include "OSMCtrlPosition.h"


//////////////////// Implementation ///////////////////////////////////////////

COSMCtrlPosition::COSMCtrlPosition(_In_ double fLongitude, _In_ double fLatitude, _In_ double fBearing, _In_ double fSpeed, _In_ bool bBearingValid, _In_ bool bSpeedValid, _In_ double fHDOP) noexcept : m_fLongitude{fLongitude},
                                                                                                                                                                                                          m_fLatitude{fLatitude},
                                                                                                                                                                                                          m_fBearing{fBearing},
                                                                                                                                                                                                          m_bBearingValid{bBearingValid},
                                                                                                                                                                                                          m_fSpeed{fSpeed},
                                                                                                                                                                                                          m_bSpeedValid{bSpeedValid},
                                                                                                                                                                                                          m_fHDOP{fHDOP}
{
}

void COSMCtrlPosition::NormalizeLongitude() noexcept
{
  while (m_fLongitude < -180)
    m_fLongitude += 360;
  while (m_fLongitude > 180)
    m_fLongitude -= 360;
}
