#include "stdafx.h"
#include "OSMCtrlApp.h"
#include "TilePropertiesDlg.h"


#pragma warning(suppress: 26433 26440 26477)
IMPLEMENT_DYNAMIC(CTilePropertiesDlg, CDialog)

#pragma warning(suppress: 26455)
CTilePropertiesDlg::CTilePropertiesDlg(_In_opt_ CWnd* pParent) : CDialog{CTilePropertiesDlg::IDD, pParent}
{
}

void CTilePropertiesDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_PROVIDER, m_sProvider);
  DDX_Text(pDX, IDC_DIMENSIONS, m_sDimensions);
  DDX_Text(pDX, IDC_CENTERPOSITION, m_sCenterPosition);
  DDX_Text(pDX, IDC_TILE_COORDINATES, m_sTileCoordinates);
  DDX_Control(pDX, IDC_URL, m_ctrlURL);
  DDX_Control(pDX, IDC_CACHE_PATH, m_ctrlCachePath);
  DDX_Control(pDX, IDC_RERENDER_URL, m_ctrlRerenderURL);
  DDX_Control(pDX, IDC_STATUS_URL, m_ctrlStatusURL);
  if (!pDX->m_bSaveAndValidate)
  {
    CString sURL;
    sURL.Format(_T("<A HREF=\"%s\" >%s</A>"), m_sURL.GetString(), m_sURL.GetString());
    m_ctrlURL.SetWindowText(sURL);

    sURL.Format(_T("<A HREF=\"%s\" >%s</A>"), m_sCachePath.GetString(), m_sCachePath.GetString());
    m_ctrlCachePath.SetWindowText(sURL);

    if (m_sRerenderURL.GetLength())
    {
      sURL.Format(_T("<A HREF=\"%s\" >%s</A>"), m_sRerenderURL.GetString(), m_sRerenderURL.GetString());
      m_ctrlRerenderURL.SetWindowText(sURL);
    }

    if (m_sStatusURL.GetLength())
    {
      sURL.Format(_T("<A HREF=\"%s\" >%s</A>"), m_sStatusURL.GetString(), m_sStatusURL.GetString());
      m_ctrlStatusURL.SetWindowText(sURL);
    }
    
    //Get the last modified timestamp of the file
    CFileStatus fileStatus;
    if (CFile::GetStatus(m_sCachePath, fileStatus))
    {
      CString sDateModified;
      const COleDateTime dateModified{fileStatus.m_mtime.GetYear(), fileStatus.m_mtime.GetMonth(), fileStatus.m_mtime.GetDay(),
                                      fileStatus.m_mtime.GetHour(), fileStatus.m_mtime.GetMinute(), fileStatus.m_mtime.GetSecond()};
      GetDlgItem(IDC_DATE_MODIFIED)->SetWindowText(dateModified.Format());
    }
  }
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTilePropertiesDlg, CDialog) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
#pragma warning(suppress: 26454)
  ON_NOTIFY(NM_CLICK, IDC_URL, &CTilePropertiesDlg::OnNMClickURL)
#pragma warning(suppress: 26454)
  ON_NOTIFY(NM_CLICK, IDC_CACHE_PATH, &CTilePropertiesDlg::OnNMClickCachePath)
#pragma warning(suppress: 26454)
  ON_NOTIFY(NM_CLICK, IDC_RERENDER_URL, &CTilePropertiesDlg::OnNMClickURL)
#pragma warning(suppress: 26454)
  ON_NOTIFY(NM_CLICK, IDC_STATUS_URL, &CTilePropertiesDlg::OnNMClickURL)
END_MESSAGE_MAP()

#pragma warning(suppress: 26429 26440 26461)
void CTilePropertiesDlg::OnNMClickURL(NMHDR* pNMHDR, LRESULT* pResult)
{
#pragma warning(suppress: 26490)
  const auto pNMLink{reinterpret_cast<const NMLINK*>(pNMHDR)};
#pragma warning(suppress: 26485)
  ShellExecuteW(nullptr, L"open", pNMLink->item.szUrl, nullptr, nullptr, SW_SHOWNORMAL);
  *pResult = 0;
}

#pragma warning(suppress: 26429 26440 26461)
void CTilePropertiesDlg::OnNMClickCachePath(NMHDR* pNMHDR, LRESULT* pResult)
{
#pragma warning(suppress: 26490)
  const auto pNMLink{reinterpret_cast<const NMLINK*>(pNMHDR)};
#pragma warning(suppress: 26485)
  ShellExecuteW(nullptr, L"open", pNMLink->item.szUrl, nullptr, nullptr, SW_SHOWNORMAL);
  *pResult = 0;
}
